PROGRAM CREATPLS;

VAR
   INFILE, OUTFILE : TEXT;
   GAP, FACTOR : INTEGER;
   SPACE : CHAR;
   FORM, DER, MCVS : STRING[3];


BEGIN
   ASSIGN (INFILE, 'LIST.TXT');
   RESET (INFILE);
   ASSIGN (OUTFILE, 'PLSTWOAF.SAS');
   REWRITE (OUTFILE);
       WRITELN (OUTFILE, '%MACRO PLSTWOAF;');
       WRITELN (OUTFILE);

   WHILE NOT EOF(INFILE) DO
       BEGIN
       READLN (INFILE, DER, SPACE, FORM, SPACE, MCVS, SPACE, GAP, FACTOR);
       WRITELN (OUTFILE, 'DATA TEMP; SET TOTAL;');
       WRITELN (OUTFILE, 'IF IDERIVAT = ','''', DER, '''',';');
       WRITELN (OUTFILE, 'IF IFORM = ','''', FORM, '''',';');
       WRITELN (OUTFILE, 'IF IMCVS = ','''', MCVS, '''',';');
       WRITELN (OUTFILE, 'IF IGAPS = ','''', GAP, '''',';');
       WRITELN (OUTFILE);


       WRITELN (OUTFILE, '%IF &MCOPTION = "PRO" %THEN %DO;');
       WRITELN (OUTFILE, '      PROC PLS DATA = TEMP METHOD = &METHOD NOCENTER NOSCALE NFAC = ', FACTOR,' NOPRINT;');
       WRITELN (OUTFILE, '            MODEL CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS = ABS1-ABS&MAXINDEX;');
       WRITE   (OUTFILE, '            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTES&FIRSTCLASS');
       WRITELN (OUTFILE, '-P_CHEMANALYTES&LASTCLASS  XSCORE = T;');
       WRITELN (OUTFILE, '            RUN;');
       WRITELN (OUTFILE, '%END; /* END MCOPTION = PRO */ ');
       WRITELN (OUTFILE, '    ');
       WRITELN (OUTFILE, '%ELSE %IF &MCOPTION = "SAS" %THEN %DO;');
       WRITELN (OUTFILE, '      PROC PLS DATA = TEMP  METHOD = &METHOD NFAC = ', FACTOR,' NOPRINT;');
       WRITELN (OUTFILE, '            MODEL CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS = ABS1-ABS&MAXINDEX;');
       WRITE   (OUTFILE, '            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTES&FIRSTCLASS');
       WRITELN (OUTFILE, '-P_CHEMANALYTES&LASTCLASS  XSCORE = T;');
       WRITELN (OUTFILE, '            RUN;');
       WRITELN (OUTFILE, '%END; /* END MCOPTION = SAS */ ');
       WRITELN (OUTFILE, '    ');
       WRITELN (OUTFILE, '%ELSE %DO;');
       WRITELN (OUTFILE, '      PROC PLS DATA = TEMP  METHOD = &METHOD NOCENTER NOSCALE NFAC = ', FACTOR,' NOPRINT;');
       WRITELN (OUTFILE, '            MODEL CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS = ABS1-ABS&MAXINDEX;');
       WRITE   (OUTFILE, '            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTES&FIRSTCLASS');
       WRITELN (OUTFILE, '-P_CHEMANALYTES&LASTCLASS  XSCORE = T;');
       WRITELN (OUTFILE, '            RUN;');
       WRITELN (OUTFILE, '%END; /* END ELSE OPTION */ ');
       WRITELN (OUTFILE);



       WRITELN (OUTFILE, 'DATA VALIDAT; INFILE ','"&VALIDATIONFILE"',';' );
       WRITELN (OUTFILE, 'INPUT ID $ IDLABEL $ OANALYTE1 - OANALYTE&MAXVARS;' );
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE, 'PROC SORT DATA = VALIDAT;' );
       WRITELN (OUTFILE, '     BY ID;' );
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE, 'DATA PREDVAL; SET PREDCHEMANALYTE;' );
       WRITELN (OUTFILE, 'IF CHEMANALYTES&FIRSTCLASS NE  . THEN DELETE;' );
       WRITELN (OUTFILE, 'PROC SORT; BY ID;' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;' );
       WRITELN (OUTFILE, '     BY ID;' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'DATA SAVPREDACTVAL; SET ORIGPREDVAL;');
       WRITELN (OUTFILE, 'CALVAL = ', '''', 'VAL', '''',';');
       WRITELN (OUTFILE, 'CHEM = &X;');
       WRITE (OUTFILE, 'KEEP CHEM IDLABEL CALVAL IFORM IDERIVAT IMCVS IGAPS ID OANALYTE&FIRSTCLASS - OANALYTE&LASTCLASS ');
       WRITELN (OUTFILE, ' P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT ;' );
       WRITELN (OUTFILE, '     VAR OANALYTE&X; WITH P_CHEMANALYTES&X;' );
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'DATA SQUAREDVALIDATION; SET VALCORROUT;' );
       WRITELN (OUTFILE, 'IF _TYPE_ = ','''','CORR','''',' THEN' );
       WRITELN (OUTFILE, '     OANALYTE&X = OANALYTE&X*OANALYTE&X;' );
       WRITELN (OUTFILE, 'ELSE ' );
       WRITELN (OUTFILE, '     DELETE;' );
       WRITELN (OUTFILE, '' );


       WRITELN (OUTFILE, 'DATA PREDVAL; SET ORIGPREDVAL;');
       WRITELN (OUTFILE, 'DIF = OANALYTE&X - P_CHEMANALYTES&X;');
       WRITELN (OUTFILE, 'DSQ = DIF * DIF;');
       WRITELN (OUTFILE);

       WRITELN (OUTFILE, 'PROC SUMMARY;');
       WRITELN (OUTFILE, 'VAR DIF DSQ;');
       WRITELN (OUTFILE, 'OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;');
       WRITELN (OUTFILE, 'RUN;');

       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMVAL;');
       WRITELN (OUTFILE, 'VPRESS = SDSQ;');
       WRITELN (OUTFILE, 'VRMSD = SQRT (VPRESS/&NUMVALFILES);');
       WRITELN (OUTFILE, 'VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));');
       WRITELN (OUTFILE, 'VBIAS = SDIF/&NUMVALFILES;');
       WRITELN (OUTFILE, 'VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMSTATS;');
       WRITELN (OUTFILE, 'DROP _TYPE_;');
       WRITELN (OUTFILE, 'DROP _FREQ_;');

       WRITELN (OUTFILE, 'DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;');

       WRITELN (OUTFILE, 'TITLE "CALIBRATION RESULTS";' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;' );
       WRITELN (OUTFILE, '     VAR CHEMANALYTES&X; WITH P_CHEMANALYTES&X;' );
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'DATA SQUAREDCAL; SET CALCORROUT;' );
       WRITELN (OUTFILE, 'IF _TYPE_ = ','''','CORR', '''',' THEN');
       WRITELN (OUTFILE, '     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;' );
       WRITELN (OUTFILE, 'ELSE' );
       WRITELN (OUTFILE, '     DELETE;' );
       WRITELN (OUTFILE, '' );
       WRITELN (OUTFILE, 'DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;' );

       WRITELN (OUTFILE, 'DATA PREDCAL; SET PREDCHEMANALYTE;');
       WRITELN (OUTFILE, 'IF CHEMANALYTES&X = . THEN DELETE;');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'DATA SAVPREDACTCAL; SET PREDCAL;');
       WRITELN (OUTFILE, 'CALVAL = ', '''', 'CAL', '''',';');
       WRITELN (OUTFILE, 'CHEM = &X;');
       WRITE (OUTFILE, 'KEEP CHEM IDLABEL CALVAL IFORM IDERIVAT IMCVS IGAPS ID CHEMANALYTES&FIRSTCLASS');
       WRITELN (OUTFILE, ' - CHEMANALYTES&LASTCLASS P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;');



       WRITELN (OUTFILE, 'RUN;');

       WRITELN (OUTFILE, 'PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE, 'DATA PREDCAL; SET PREDCAL;');
       WRITELN (OUTFILE, 'DIF = CHEMANALYTES&X - P_CHEMANALYTES&X;');
       WRITELN (OUTFILE, 'DSQ = DIF * DIF;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE, 'PROC SUMMARY;');
       WRITELN (OUTFILE, 'VAR DIF DSQ;');
       WRITELN (OUTFILE, 'OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMCAL;');
       WRITELN (OUTFILE, 'PRESS = SDSQ;');
       WRITELN (OUTFILE, 'RMSD = SQRT (PRESS/&NUMCALFILES);');
       WRITELN (OUTFILE, 'SEP = SQRT (PRESS/(&NUMCALFILES - 1));');
       WRITELN (OUTFILE, 'BIAS = SDIF/&NUMCALFILES;');
       WRITELN (OUTFILE, 'SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));');
       WRITELN (OUTFILE, 'RUN;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE, 'DATA SUMSTATS; SET SUMSTATS;');
       WRITELN (OUTFILE, 'DROP _TYPE_;');
       WRITELN (OUTFILE, 'DROP _FREQ_;');
       WRITELN (OUTFILE, 'DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;');

       WRITELN (OUTFILE, 'PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;');
       WRITELN (OUTFILE, 'RUN;' );
       WRITELN (OUTFILE);
       END;
       WRITELN (OUTFILE, '%MEND PLSTWOAF;');
       WRITELN (OUTFILE);
       WRITELN (OUTFILE);
       CLOSE (OUTFILE);
END.


