%GLOBAL ITERATIONS;
%LET ITERATIONS = 3;

%MACRO RUNRANDOM;
%LET FIRSTFILE = "ALL65";    /* ID OF FIRST SAMPLE TO REDUCE XSCORE REPEATS */
%LET MAXINDEX = 700;         /* NUMBER OF WAVELENGTHS PER SPECTRA */
                    /* FIRST DATAPOINT FOR 6500 DATA IS AT 400 NM AND LAST IS 2498 */
%LET STARTAT = 1;         /* FIRST SPECTRAL DATAPOINT TO USE */
%LET ENDAT = 700;        /* LAST SPECTRAL DATAPOINT TO USE  */
%LET AVSKFACTOR = 4;      /* NUMBER OF POINTS FOR AVSK */
%LET AVSK = "AVER";       /*  SKIP OR AVERAGE EVERY N POINTS*/
%LET NUMFILES = 241;
%LET MAXVARS = 6;
%LET NUMCALFILES = 161;

%GLOBAL FIRSTCLASS LASTCLASS;
%LET FIRSTCLASS = 1;
%LET LASTCLASS = 6;

%LET DIRECTORY = C:\SASDISCRIM;
%LET PREFIX = SIXCALVAL;
%LET RUNSPEC = RANDOMFORPAPER;
%LET NAMEOFLIBRARY = &DIRECTORY\GRAPHS;
%LET COMBINEDGRAPHS = STORGRAP.&PREFIX&RUNSPEC.&QQ;

OPTIONS MAUTOSOURCE;
OPTIONS SASAUTOS = ("&DIRECTORY");
X  "CD &DIRECTORY";

/* LINES 8 TO 18 CONTAIN VALUES WHICH MUST BE CHECKED AS DATA SETS ARE CHANGED */
/* LINES 20 TO 45 CONTAIN OPTIONS WHICH MAY OFTEN BE CHANGED      */


            /* ----- MACRO VARIABLES THAT SPECIFY INPUT FILES AND OTHER OPTIONS ----- */

/* SPECTRAL FILE MUST BE GRAMS MULTIFILE (NEWSTYLE, EVEN X SPACING, CONSTANT #PTS PER SPECTRUM) */

%LET MULTIFILE =&DIRECTORY\&PREFIX..SPC;

/* CORRESPONDING CONSTITUENT FILE, WITH SAMPLES IN SAME ORDER AS *.SPC FILE */
/* FORM OF GRAMS CFL FILE WITHOUT HEADER INFORMATION */

%LET CHEMFILE =&DIRECTORY\&PREFIX..PRN; /* CORRESPONDING CONSTITUENT FILE, WITH SAMPLES IN SAME ORDER AS *.SPC FILE */

%LET LOGFILE = &DIRECTORY\&PREFIX&RUNSPEC.&QQ.LOG.OUT;

%LET PRINTFILE = &DIRECTORY\&PREFIX&RUNSPEC.&QQ.OUTPUT.OUT;

PROC PRINTTO PRINT = "&PRINTFILE";
RUN;

PROC PRINTTO  LOG = "&LOGFILE";
RUN;

/* REGRESSION SETTINGS */
%LET CV = ONE; /* SPLIT (N) = EVERY NTH, BLOCK (N) = BLOCKS OF N, RANDOM (SEED = N, NITER = N, SEED = N*/
%LET METHOD = PLS; /* PLS, PCR, RRR, SIMPLS */

  /* FOR PLOTTING SPECTRA ETC. */
%LET MAXINDEXPLUS = %SYSEVALF(&MAXINDEX+1);
%LET FIRSTWN = 2500;
%LET LASTWN = 1100;
%LET BYFACTOR = 100;


%IF &NUMCALFILES ^= &NUMFILES %THEN %DO;
       %LET RANDOMIZE = "YES";
%END;
%ELSE %DO;
       %LET RANDOMIZE = "NO";
%END;


%LET NUMVALFILES = %SYSEVALF(&NUMFILES - &NUMCALFILES);
%LET FIRSTVALFILE = %SYSEVALF(&NUMCALFILES + 1);

               /* DATA FOR GAP DERIVATIVE */
%LET STARTGAP1ST = 2;   /*1ST ACTUAL GAP = TWICE THIS VALUE */
%LET ENDGAP1ST = 64;
%LET FINALCOUNT1ST = 5;   /*NONE + START TO END BY 2X*/
%LET STARTGAP2ND = 2;   /*1ST ACTUAL GAP = TWICE THIS VALUE */
%LET ENDGAP2ND = 64;
%LET FINALCOUNT2ND = 5;
%LET ODDEVENGAPS = "EVEN"; /* SET TO ODD FOR ODD GAPPED DERIVATIVES */


%LET SGYESNO = "NO";     /* YES IF SAVITSKY=GOLAY DERIVATIVES TO BE USED IN PLS */
%LET MSCYESNO = "YES"; /* YES IF MULTIPLICATIVE SCATTER CORRECTION WANTED */
%LET SNVDETYESNO = "NON"; /* BOTH, SNV OR DET ONLY TO BE BE USED IN PLS */
%LET DETONLY = "NON"; /* DO DETREND ON NON-SNV CORRECTED DATA = DTO*/
%LET MCOPTION = "SAS";    /*MC SET TO PRO (PROGRAM), SAS (SAS), OR NON (NONE) */
%LET SCALE = "NO";       /*SET TO NOSCALE OR BLANK*/
%LET SGFILE = &DIRECTORY\SAVGOLGAP.PRN;  /* LOCATION OF SAVITSKY-GOLAY CONVOLUTION TABLES */
%LET TABLEBG = 1;         /* SET TABLES FOR SAVITSY GOLAY DERIVATIVES */
%LET TABLEEND = 10;
%LET TABLEBY = 1;
%LET BEGINSG = 5;         /* FIRST LINE TO USE  FOR SG DERIVATIVE, MIN = 5*/
%LET ENDSG = 25;          /* LAST LINE TO USE  FOR SG DERIVATIVE, MAX = 25  */
%GLOBAL NAMEALLSUMCALVAL NAMEALLPREDICTACTUAL;
%LET OUTPUTFILE=&DIRECTORY\&PREFIX.COMBINED&RUNSPEC.&QQ..TXT;
%LET SUMCALVALOUTFILE = &DIRECTORY\&PREFIX.SUMCALVALOUT&RUNSPEC.&QQ..TXT;
%LET NAMEALLSUMCALVAL = &DIRECTORY\&PREFIX.SUMCALVALOUT&RUNSPEC;
%LET SASWAYOUTFILE = &DIRECTORY\&PREFIX.SASWAYOUT&RUNSPEC.&QQ..TXT;
%LET VALIDATIONFILE =&DIRECTORY\&PREFIX.COMBINEDVALIDAT&RUNSPEC.&QQ..PRN;
%LET CALPRED = &DIRECTORY\&PREFIX.COMBINEDCALPRE&RUNSPEC.&QQ..TXT;
%LET VALPRED = &DIRECTORY\&PREFIX.COMBINEDVALPRE&RUNSPEC.&QQ..TXT;
%LET COMBINEDPREDICTACTUAL = &DIRECTORY\&PREFIX.COMBINEDPREDICTACTUAL&RUNSPEC.&QQ..SAV;
%LET NAMEALLPREDICTACTUAL = &DIRECTORY\&PREFIX.COMBINEDPREDICTACTUAL&RUNSPEC;
%LET RCOMBINEDCALCFL =  &DIRECTORY\&PREFIX.RANDOMCALCFL&RUNSPEC.&QQ..CFL;
%LET RCOMBINEDVALCFL =   &DIRECTORY\&PREFIX.RANDOMVALCFL&RUNSPEC.&QQ..CFL;
%LET NAMEOFLIBRARY = &DIRECTORY\GRAPHS;
%LET COMBINEDGRAPHS = STORGRAP.&PREFIX.COMBINEDGRAPHS&RUNSPEC.&QQ;
                     /* MACRO VARIABLE WHICH DO NOT CHANGE */
%LET MAXTEMP = %SYSEVALF (&MAXINDEX * 4);  /* 4*MAXINDEX */
%LET LEFTCUT = 0; /* THE NUMBER OF SPECTRAL POINTS ON LEFT END TO CUT */
%LET RIGHTCUT = 0; /* DITTO FOR RIGHT END */
%LET INITIALLIMIT = &MAXINDEX;
%LET CHEMS = CHEMANALYTES1-CHEMANALYTES&MAXVARS;
%LET ANALYTES = ID $ IDLABEL $ &CHEMS;  /* NAMES OF ANALYTES */
%LET PRTANALYTES = ID IDLABEL &CHEMS;  /* FOR PRINTING ONLY */
%LET OUTVARS = &ANALYTES OUTABS1-OUTABS&MAXINDEX;
%LET VARLIST =&ANALYTES ABS1 - ABS&MAXINDEX;
%LET SPECS = IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST;

DATA PARAMETERS;
DIRECT = "&DIRECTORY";
FILE1 = &FIRSTFILE;
INDEX = &MAXINDEX;
BEGIN = &STARTAT;
ENDAT = &ENDAT;
AVER = &AVSKFACTOR;
NUMOFFILES = &NUMFILES;
NUMOFVARS = &MAXVARS;
FIRSTVAR = &FIRSTCLASS;
LASTVAR = &LASTCLASS;
PLOTSTART = &FIRSTWN;
PLOTEND = &LASTWN;
PLOTFACTOR = &BYFACTOR;
NUMOFCALFILES = &NUMCALFILES;
NUMOFVALFILES = &NUMVALFILES;
STARTVALFILES = &FIRSTVALFILE;
CV = "&CV";
METHOD = "&METHOD";
FILEPRE = "&PREFIX";
FILERUN = "&RUNSPEC";
RANDOMQQ = &QQ;
RANDOM = &RANDOMIZE;
START1STGAP= &STARTGAP1ST;
END1STGAP =&ENDGAP1ST;
COUNT1ST =&FINALCOUNT1ST;
START2NDGAP =&STARTGAP2ND;
EN2NDGAP =&ENDGAP2ND;
COUNT2ND =&FINALCOUNT2ND;
ODDEVEN =&ODDEVENGAPS;
SAVISTYG =&SGYESNO;
MULTI  =&MSCYESNO;
STAND =&SNVDETYESNO;
DETRENT =&DETONLY;
MEANCENTER =&MCOPTION;
FIRSTSGTABLE =&TABLEBG;
LASTSGTABLE =&TABLEEND;
BYTABLE =&TABLEBY;
STARTSG =&BEGINSG;
ENDSG =&ENDSG;
PROC PRINT DATA = PARAMETERS;
RUN;

/*MACRO THAT READS A SINGLE NEWSTYLE GRAMS MULTIFILE;*/

%MACRO GETSPECONE;

DATA MULTIFILE;
ARRAY X(&MAXTEMP) X1-X&MAXTEMP;
ARRAY Y(&MAXINDEX) ABS1-ABS&MAXINDEX;
INFILE "&MULTIFILE" RECFM=N;
INPUT @2 SPCVERSION IBR1.;
IF SPCVERSION < 0 THEN SPCVERSION = SPCVERSION + 256;
IF SPCVERSION ^= 75 THEN ABORT;
INPUT @5 NUMPOINTS1 IBR1. NUMPOINTS2 IBR1. @24 +1 NUMSPEC1 IBR1. NUMSPEC2 IBR1. @512;
IF NUMPOINTS1 < 0 THEN NUMPOINTS1 = NUMPOINTS1 + 256;
IF NUMPOINTS2 < 0 THEN NUMPOINTS2 = NUMPOINTS2 + 256;
NUMPOINTS = NUMPOINTS2*256 + NUMPOINTS1;
LEFTEDGE = &LEFTCUT + 1;
ATTRIB CHARLEFT FORMAT = $CHAR.;
CHARLEFT = LEFTEDGE;
CHARLEFT = COMPRESS(CHARLEFT);
CALL SYMPUT('LEFTSPEC',CHARLEFT);
RIGHTEDGE = NUMPOINTS - &RIGHTCUT;
ATTRIB CHARRIGHT FORMAT = $CHAR.;
CHARRIGHT = RIGHTEDGE;
CHARRIGHT = COMPRESS(CHARRIGHT);
CALL SYMPUT('RIGHTSPEC',CHARRIGHT);
NEWNUMPOINTS = NUMPOINTS - &LEFTCUT - &RIGHTCUT;
ATTRIB CHARNEWNUMPOINTS FORMAT = $CHAR.;
CHARNEWNUMPOINTS = NEWNUMPOINTS;
CALL SYMPUT('NEWPOINTS',CHARNEWNUMPOINTS);
IF NUMSPEC1 < 0 THEN NUMSPEC1 = NUMSPEC1 + 256;
IF NUMSPEC2 < 0 THEN NUMSPEC2 = NUMSPEC2 + 256;
NUMRECORDS = NUMSPEC2*256 + NUMSPEC1;
ATTRIB CHARREC FORMAT = $CHAR.;
CHARREC = NUMRECORDS;
CHARREC = COMPRESS(CHARREC);
CALL SYMPUT('NREC',CHARREC);

DO M=1 TO NUMRECORDS;
    IF M = 1 THEN INPUT +2 MULT IBR1. (JUNK1-JUNK6) (IBR1.) +24;
    ELSE INPUT +1 MULT IBR1. (JUNK1-JUNK6) (IBR1.) +24;
    IF MULT < 0 THEN MULT = MULT + 256;
    IF MULT >= 128 THEN MULT = MULT - 256;
    MULT = 2 ** (MULT - 32);

    DO N = 1 TO NUMPOINTS*4;
        INPUT X(N) IBR1.;
    END;

    DO I=4 TO NUMPOINTS*4 BY 4;
        DO J = 0 TO 3 BY 1;
            IF X(I-J) < 0 THEN X(I-J) = X(I-J) + 256;
        END; /* J */

        SIGN = 1;
        IF X(I) >= 128 THEN SIGN = -1;
        K = I / 4;
        Y(K) = ( X(I-3) + X(I-2)*256 + X(I-1)*65536 + X(I)*16777216 );
        IF SIGN < 0 THEN Y(K) = -(4294967296 - Y(K));
        Y(K) = MULT * Y(K);
    END; /* END I */
/*    %IF &MAXINDEX ^= NUMPOINTS %THEN %DO;
            ABORT RETURN;
    %END;*/
    OUTPUT;
END; /* END M */

STOP;
FORMAT ABS1-ABS&MAXINDEX F13.10;
%IF &NUMFILES ^= NUMRECORDS  %THEN %DO;
ABORT RETURN;
%END;
KEEP ABS1-ABS&MAXINDEX;
RUN;

%MEND GETSPECONE;

%MACRO GETSPECTWO;

/* S.R. DELWICHE, USDA/ARS/BA/ANRI/ISL, BUILDING 303, BARC-EAST, BELTSVILLE, MD 20705-2350 USA, DELWICHE@BA.ARS.USDA.GOV
  PROGRAM FILENAME: READ_A_GRAMS_NEWSTYLE_MULTIFILE_WITH_IEEE_SPECTRAL_FORMAT_JAN2005.SAS
  DATE LAST MODIFIED: JANUARY 13, 2003   BY JAMES B. REEVES, III
       */

/*  SAME AS 'READ_A_GRAMS_NEWSTYLE_MULTIFILE_WITH_IEEE_SPECTRAL_FORMAT.SAS', ORIGINALLY WRITTEN IN MAY 2003. */

/* ........................................... 1 START .......................................... */

/* ----- MACRO VARIABLES THAT SELDOM NEED CHANGING ----- */
%LET PROGNAME=READ_A_GRAMS_NEWSTYLE_MULTIFILE_WITH_IEEE_SPECTRAL_FORMAT_JAN2005.SAS;

/* ----- MACRO VARIABLES THAT TRUNCATE THE SPECTRAL REGION BEFORE ANY OTHER PREPROCESSING ----- */
%LET  LEFTCUT = 0; /* THE NUMBER OF SPECTRAL POINTS ON LEFT END TO CUT */
%LET RIGHTCUT = 0; /* DITTO FOR RIGHT END */

/* ........................................... 1 END ............................................ */


/* MACRO THAT READS A SINGLE NEWSTYLE GRAMS MULTIFILE (EVENLY SPACED X VALUES), WITH
   SPECTRAL VALUES STORED IN IEEE FORMAT, RATHER THAN FIXED BINARY INTEGER, WHICH WAS THE
   CONVENTIONAL WAY THAT GRAMS USED UNTIL SEVERAL YEARS AGO. */


/* ........................................... 2 START .......................................... */

  DATA MULTIFILE;
  ARRAY Y(&MAXINDEX) ABS1-ABS&MAXINDEX;
  INFILE "&MULTIFILE" RECFM=N;
  INPUT @2 SPCVERSION IBR1.;
  IF SPCVERSION < 0 THEN SPCVERSION = SPCVERSION + 256;
  IF SPCVERSION ^= 75 THEN ABORT;
  INPUT @5 NUMPOINTS1 IBR1. NUMPOINTS2 IBR1. @24 +1 NUMSPEC1 IBR1. NUMSPEC2 IBR1. @512;
  IF NUMPOINTS1 < 0 THEN NUMPOINTS1 = NUMPOINTS1 + 256;
  IF NUMPOINTS2 < 0 THEN NUMPOINTS2 = NUMPOINTS2 + 256;
  NUMPOINTS = NUMPOINTS2*256 + NUMPOINTS1;

  LEFTEDGE = &LEFTCUT + 1;
  ATTRIB CHARLEFT FORMAT = $CHAR.;
  CHARLEFT = LEFTEDGE;
  CHARLEFT = COMPRESS(CHARLEFT);
  CALL SYMPUT('LEFTSPEC',CHARLEFT);
  RIGHTEDGE = NUMPOINTS - &RIGHTCUT;
  ATTRIB CHARRIGHT FORMAT = $CHAR.;
  CHARRIGHT = RIGHTEDGE;
  CHARRIGHT = COMPRESS(CHARRIGHT);
  CALL SYMPUT('RIGHTSPEC',CHARRIGHT);
  NEWNUMPOINTS = NUMPOINTS - &LEFTCUT - &RIGHTCUT;
  ATTRIB CHARNEWNUMPOINTS FORMAT = $CHAR.;
  CHARNEWNUMPOINTS = NEWNUMPOINTS;
  CALL SYMPUT('NEWPOINTS',CHARNEWNUMPOINTS);
  IF NUMSPEC1 < 0 THEN NUMSPEC1 = NUMSPEC1 + 256;
  IF NUMSPEC2 < 0 THEN NUMSPEC2 = NUMSPEC2 + 256;
  NUMRECORDS = NUMSPEC2*256 + NUMSPEC1;
  ATTRIB CHARREC FORMAT = $CHAR.;
  CHARREC = NUMRECORDS;
  CHARREC = COMPRESS(CHARREC);
  CALL SYMPUT('NREC',CHARREC);
  DO M=1 TO NUMRECORDS;
    IF M = 1 THEN INPUT +2 MULT IBR1. (JUNK1-JUNK6) (IBR1.) +24;
    ELSE INPUT +1 MULT IBR1. (JUNK1-JUNK6) (IBR1.) +24;

/* THE FOLLOWING LOOP IS WHERE THE DATA STEP DEPARTS FROM
   THE ONE THAT READS FIXED BINARY INTEGER DATA. */

    DO N = 1 TO NUMPOINTS;
      INPUT Y(N) FLOAT4.;
    END;
    OUTPUT;
  END;
  STOP;
  %IF &NUMFILES ^= NUMRECORDS  %THEN %DO;
  ABORT RETURN;
  %END;
  FORMAT ABS1-ABS&MAXINDEX F13.10;
  KEEP ABS1-ABS&MAXINDEX;

  RUN;

/* ........................................... 2 END ............................................ */

%MEND GETSPECTWO;


%MACRO GETSPECTHREE; /* READS AND ISI NIR FILE */


/* S.R. DELWICHE, USDA/ARS/BA/ANRI/ISL, BUILDING 303, BARC-EAST, BELTSVILLE, MD 20705-2350 USA, DELWICHE@BA.ARS.USDA.GOV
  PROGRAM FILENAME: READ_AN_ISI_NIR_FILE.SAS
  DATE LAST MODIFIED: JANUARY 12, 2003                                                                                  */

/*  MODIFIED FORM OF 'READ_A_GRAMS_NEWSTYLE_MULTIFILE_WITH_IEEE_SPECTRAL_FORMAT_JAN2005.SAS'. */

/* ........................................... 1 START .......................................... */

/* ----- MACRO VARIABLES THAT SELDOM NEED CHANGING ----- */

%LET MAXINDEX = 1050; /* MAXIMUM NUMBER OF SPECTRAL DATA POINTS */
%LET MAXB = 4200; /* 4*MAXINDEX */

/* ----- MACRO VARIABLE THAT SPECIFIES INPUT FILE ------ */

/* ----- MACRO VARIABLES THAT TRUNCATE THE SPECTRAL REGION BEFORE ANY OTHER PREPROCESSING ----- */
%LET  LEFTCUT = 0; /* THE NUMBER OF SPECTRAL POINTS ON LEFT END TO CUT */
%LET RIGHTCUT = 0; /* DITTO FOR RIGHT END */

/* ........................................... 1 END ............................................ */

/* MACRO THAT READS AN ISI *.NIR FILE (EVENLY SPACED X VALUES), WITH
   SPECTRAL VALUES STORED IN IEEE FORMAT. */

/* ........................................... 2 START .......................................... */

  DATA MULTIFILE;
  ARRAY Y(&MAXINDEX) ABS1-ABS&MAXINDEX;
  INFILE "&MULTIFILE" RECFM=N;
  INPUT @3 NUMSPEC1 IBR1. NUMSPEC2 IBR1. @7 NUMPOINTS1 IBR1. NUMPOINTS2 IBR1. @1153;
  IF NUMPOINTS1 < 0 THEN NUMPOINTS1 = NUMPOINTS1 + 256;
  IF NUMPOINTS2 < 0 THEN NUMPOINTS2 = NUMPOINTS2 + 256;
  NUMPOINTS = NUMPOINTS2*256 + NUMPOINTS1;

  LEFTEDGE = &LEFTCUT + 1;
  ATTRIB CHARLEFT FORMAT = $CHAR.;
  CHARLEFT = LEFTEDGE;
  CHARLEFT = COMPRESS(CHARLEFT);
  CALL SYMPUT('LEFTSPEC',CHARLEFT);
  RIGHTEDGE = NUMPOINTS - &RIGHTCUT;
  ATTRIB CHARRIGHT FORMAT = $CHAR.;
  CHARRIGHT = RIGHTEDGE;
  CHARRIGHT = COMPRESS(CHARRIGHT);
  CALL SYMPUT('RIGHTSPEC',CHARRIGHT);
  NEWNUMPOINTS = NUMPOINTS - &LEFTCUT - &RIGHTCUT;
  ATTRIB CHARNEWNUMPOINTS FORMAT = $CHAR.;
  CHARNEWNUMPOINTS = NEWNUMPOINTS;
  CALL SYMPUT('NEWPOINTS',CHARNEWNUMPOINTS);
  IF NUMSPEC1 < 0 THEN NUMSPEC1 = NUMSPEC1 + 256;
  IF NUMSPEC2 < 0 THEN NUMSPEC2 = NUMSPEC2 + 256;
  NUMRECORDS = NUMSPEC2*256 + NUMSPEC1;
  ATTRIB CHARREC FORMAT = $CHAR.;
  CHARREC = NUMRECORDS;
  CHARREC = COMPRESS(CHARREC);
  CALL SYMPUT('NREC',CHARREC);
  DO M=1 TO NUMRECORDS;

/* THE FOLLOWING LOOP READS IN THE SPECTRAL DATA, PLUS 408 JUNK
   BYTES OF FOOTER INFORMATION. */

    DO N = 1 TO NUMPOINTS;
      INPUT Y(N) FLOAT4.;
    END;
    INPUT (JUNK1-JUNK408) (IBR1.);
    OUTPUT;
  END;
  STOP;
  FORMAT ABS1-ABS&MAXINDEX F13.10;
  KEEP ABS1-ABS&MAXINDEX NUMPOINTS NUMRECORDS;
  RUN;

/* ........................................... 2 END ............................................ */

%MEND GETSPECTHREE;


%MACRO ALTERNATEINPUT;
LIBNAME CURRENT "&DIRECTORY";
DATA STEVE; SET CURRENT.STEVESDATA;
WILD = CAT1_WILD;
ANUL = CAT2_ANUL;
BNUL = CAT3_BNUL;
WAXY = CAT4_WAXY;
FORMAT ZE1-ZE128 F13.10;
KEEP ZE1-ZE128 WILD ANUL BNUL WAXY;

/*PROC PRINT;
RUN;*/

DATA STEVE; SET STEVE;
ID = 'STEV';
IDLABEL = 'ALLEL';
FILENUM = _N_;
FILE 'STEVEOUT.DAT';
PUT ID $  IDLABEL $ FILENUM WILD ANUL BNUL WAXY ZE1-ZE128 F13.10;
RUN;

DATA STEVE; INFILE 'STEVEOUT.DAT';
INPUT ID $  IDLABEL $ FILENUM $ WILD ANUL BNUL WAXY ZE1-ZE128;
ID = CATS(ID, FILENUM);
DROP FILENUM;
RUN;

PROC SORT DATA = STEVE;
BY WILD ANUL BNUL WAXY;
RUN;

DATA STEVE; SET STEVE;
FILE 'STEVEOUT.DAT';
PUT ID $ IDLABEL $ WILD ANUL BNUL WAXY ZE1-ZE128;
RUN;

DATA WORKFILE; INFILE 'STEVEOUT.DAT';
INPUT &VARLIST;
RUN;

/*PROC PRINT DATA = WORKFILE;
RUN;
*/
%MEND;

%MACRO ALTERNATEINPUTII;
LIBNAME CURRENT "&DIRECTORY";
DATA STEVE; SET CURRENT.STEVESCALIBRATION;
LABEL = 'CALIBRATION';
WILD = CAT1_WILD;
ANUL = CAT2_ANUL;
BNUL = CAT3_BNUL;
WAXY = CAT4_WAXY;
FORMAT ZE11-ZE128 F13.10;
KEEP ZE11-ZE128 WILD ANUL BNUL WAXY;


DATA STEVE; SET STEVE;
ID = 'STEV';
IDLABEL = 'ALLEL';
FILENUM = _N_;
FILE 'STEVEOUTCAL.DAT';
PUT ID $ IDLABEL $ FILENUM WILD ANUL BNUL WAXY ZE11-ZE128 F13.10;
RUN;

DATA STEVE; INFILE 'STEVEOUTCAL.DAT';
INPUT ID $ IDLABEL $ FILENUM $ WILD ANUL BNUL WAXY ZE11-ZE128;
ID = CATS(ID, FILENUM);
DROP FILENUM;
RUN;

PROC SORT DATA = STEVE;
BY WILD ANUL BNUL WAXY;
RUN;

DATA STEVE; SET STEVE;
FILE 'STEVEOUTCAL.DAT';
PUT ID $  IDLABEL $ WILD ANUL BNUL WAXY ZE11-ZE128;
RUN;

DATA WORKFILE; INFILE 'STEVEOUTCAL.DAT';
INPUT &VARLIST;
RUN;
/*PROC PRINT DATA = WORKFILE;
RUN;
*/




DATA STEVE; SET CURRENT.STEVESVALIDATION;
LABEL = 'VALIDATION';
WILD = CAT1_WILD;
ANUL = CAT2_ANUL;
BNUL = CAT3_BNUL;
WAXY = CAT4_WAXY;
FORMAT ZE11-ZE128 F13.10;
KEEP ZE11-ZE128 WILD ANUL BNUL WAXY;

DATA STEVE; SET STEVE;
ID = 'STEV';
IDLABEL = 'ALLEL';
FILENUM = _N_ + &NUMCALFILES;
FILE 'STEVEOUTVAL.DAT';
PUT ID $ IDLABEL $ FILENUM WILD ANUL BNUL WAXY ZE11-ZE128 F13.10;
RUN;

DATA STEVE; INFILE 'STEVEOUTVAL.DAT';
INPUT ID $ IDLABEL $ FILENUM $ WILD ANUL BNUL WAXY ZE11-ZE128;
ID = CATS(ID, FILENUM);
DROP FILENUM;
RUN;

PROC SORT DATA = STEVE;
BY WILD ANUL BNUL WAXY;
RUN;

DATA STEVE; SET STEVE;
FILE 'STEVEOUTVAL.DAT';
PUT ID $ IDLABEL $ WILD ANUL BNUL WAXY ZE11-ZE128;
RUN;

DATA WORKFILEII; INFILE 'STEVEOUTVAL.DAT';
INPUT &VARLIST;
RUN;
/*PROC PRINT DATA = WORKFILEII;
RUN;*/

PROC APPEND BASE = WORKFILE DATA = WORKFILEII FORCE;
RUN;

DATA WORKFILE; SET WORKFILE;
LABEL = 'COMBINED';
RUN;
/*PROC PRINT DATA = WORKFILE;
RUN;
*/

DATA RANDOMIZED; SET WORKFILE;

%IF &RANDOMIZE = "YES" %THEN %DO;
RANDOMX = RANUNI (0);
PROC SORT DATA = RANDOMIZED;
BY RANDOMX;
%END;


DATA CAL; SET RANDOMIZED (OBS=&NUMCALFILES);
%IF &RANDOMIZE = "YES" %THEN %DO;
DROP RANDOMX;
%END;


PROC SQL;
SELECT COUNT(*) AS NUMCALFILES FROM WORK.CAL;
RUN;

DATA VALIDATION; SET RANDOMIZED (FIRSTOBS=&FIRSTVALFILE);
%IF &RANDOMIZE = "YES" %THEN %DO;
DROP RANDOMX;
%END;
RUN;

PROC SQL;
SELECT COUNT(*) AS NUMVALFILES FROM WORK.VALIDATION;
RUN;

%LET NUMFILES = %SYSEVALF(&NUMCALFILES + &NUMVALFILES);


DATA VALNODATA; SET VALIDATION;
%DO X = 1 %TO &MAXVARS;
    CHEMANALYTES&X = .;
%END;
RUN;
PROC APPEND BASE = CAL DATA = VALNODATA FORCE;
RUN;

DATA WORKFILE; SET CAL;
RUN;

DATA VALIDATION; SET VALIDATION;
FILE "&VALIDATIONFILE";
PUT &ANALYTES;
RUN;

%MEND;





/* MACRO THAT READS AN ASCII FILE THAT CONTAINS ID AND CHEMICAL INFORMATION */

%MACRO GETCHEM;

DATA CHEMDATA;
INFILE "&CHEMFILE";
INPUT &ANALYTES;

DATA CHEMDATA; SET CHEMDATA;
SET NOBS = NUMOFFILES;
IF &NUMFILES ^= NUMOFFILES THEN ABORT ABEND;

DATA WORKFILE;
MERGE MULTIFILE CHEMDATA;
RUN;

DATA RANDOMIZED; SET WORKFILE;

%IF &RANDOMIZE = "YES" %THEN %DO;
RANDOMX = RANUNI (0);
PROC SORT DATA = RANDOMIZED;
BY RANDOMX;
%END;

DATA CAL; SET RANDOMIZED (OBS=&NUMCALFILES);
%IF &RANDOMIZE = "YES" %THEN %DO;
DROP RANDOMX;
%END;

PROC SQL;
SELECT COUNT(*) AS NUMCALFILES FROM WORK.CAL;
RUN;

DATA VALIDATION; SET RANDOMIZED (FIRSTOBS=&FIRSTVALFILE);
%IF &RANDOMIZE = "YES" %THEN %DO;
DROP RANDOMX;
%END;
RUN;

PROC SQL;
SELECT COUNT(*) AS NUMVALFILES FROM WORK.VALIDATION;
RUN;

%LET NUMFILES = %SYSEVALF(&NUMCALFILES + &NUMVALFILES);


DATA VALNODATA; SET VALIDATION;
%DO X = 1 %TO &MAXVARS;
    CHEMANALYTES&X = .;
%END;
RUN;
PROC APPEND BASE = CAL DATA = VALNODATA FORCE;
RUN;

DATA WORKFILE; SET CAL;
RUN;

DATA VALIDATION; SET VALIDATION;
FILE "&VALIDATIONFILE";
PUT &ANALYTES;
RUN;

DATA MULTIFILE; SET MULTIFILE;
DROP _ALL_;
DATA CHEMDATA; SET CHEMDATA;
DROP _ALL_;
RUN;
%MEND GETCHEM;


%MACRO OVERHEAD;

DATA WORKFILE; SET WORKFILE;
ARRAY FORM[1] $ IFORM;
ARRAY MCVS[1] $ IMCVS;
ARRAY DERIVAT[1] $ IDERIVAT;
ARRAY GAPS[1] IGAPS;
ARRAY FIRST[1] IFIRST;
ARRAY LAST[1] ILAST;
ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
FORM[1] = 'STR';

IF &MCOPTION = "PRO" THEN
    MCVS[1] = 'PRO';
ELSE IF &MCOPTION = "SAS" THEN
    MCVS[1] = 'SAS';
ELSE
    MCVS[1] = 'NON';


DERIVAT[1] = 'NON';
GAPS[1] = 0;
FIRST[1] = &STARTAT;
LAST[1] = &ENDAT;

DO I = 1 TO (&STARTAT - 1);
    TEMPABS[I] = .;
END;

DO I = (&ENDAT + 1) TO &MAXINDEX;
    TEMPABS[I] = .;
END;

DROP I;

%MEND OVERHEAD;


%MACRO GAPSGDERIVATIVES;

%IF &SGYESNO = "YES" %THEN %DO;

DATA INSAVITSKY; SET WORKFILE;
DATA SAVITSKYDERIVATIVES; SET WORKFILE;
DATA SAVGOL; INFILE "&SGFILE";

DO TABLE = 1 TO &TABLEEND;
    DO ROW = 1 TO 14;
        INPUT C1-C11;
        OUTPUT;
    END; /* ROW */
END; /* TABLE */


%DO TABLEINDEX = &TABLEBG %TO &TABLEEND %BY &TABLEBY;
    %IF &TABLEINDEX > 10 %THEN ABORT ABEND;
    DATA CHOSENTABLE; SET SAVGOL;
    IF TABLE ^= &TABLEINDEX THEN DELETE;

    PROC TRANSPOSE DATA=CHOSENTABLE OUT=T_CHOSENTABLE;
        VAR C1-C11;

    %DO LINEINDEX = &BEGINSG %TO &ENDSG %BY 2;
        DATA CONVOLUTE; SET T_CHOSENTABLE;
        SG_PTS = &LINEINDEX;
        RENAME COL1=R1 COL2=R2 COL3=R3 COL4=R4 COL5=R5 COL6=R6 COL7=R7 COL8=R8 COL9=R9
        COL10=R10 COL11=R11 COL12=R12 COL13=R13 COL14=R14;

        IF &TABLEINDEX = 3 OR &TABLEINDEX = 4 OR &TABLEINDEX = 5 OR &TABLEINDEX = 9 THEN
            SIGN = -1;
        ELSE SIGN = 1;

        KEEP SIGN SG_PTS COL1-COL14;
        IF _N_ ^= 13.5 - SG_PTS/2 THEN DELETE;

        PROC SQL BUFFERSIZE=128000;
            CREATE TABLE COMBINED AS
            SELECT *
            FROM CONVOLUTE, INSAVITSKY;


        DATA FINSAVITSKY; SET COMBINED;
        START=IFIRST;
        FINAL=ILAST;
        ARRAY DER[&MAXINDEX];
        ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
        ARRAY R(14) R1-R14;
        LINECOUNTER = FLOOR((&LINEINDEX-3)/2);
        NEWSTART = (SG_PTS+1)/2 + (START-1);
        NEWEND = FINAL - (SG_PTS-1)/2;
        FIRST = NEWSTART;
        LAST = NEWEND;
        ATTRIB CHARSTART FORMAT = $CHAR.;
        CHARSTART = NEWSTART;
        CHARSTART = COMPRESS(CHARSTART);
        CALL SYMPUT('STARTTRIM',CHARSTART);
        ATTRIB CHAREND FORMAT = $CHAR.;
        CHAREND = NEWEND;
        CHAREND = COMPRESS(CHAREND);
        CALL SYMPUT('ENDTRIM',CHAREND);

        DO A = NEWSTART TO NEWEND;
            SUM = 0.0;

            DO AA = (14 - (SG_PTS+1)/2) TO 13;
                SUM = SUM +  R[AA] * TEMPABS[A-(13-AA)];
            END; /* END AA */

            DO AA = (14 - (SG_PTS+1)/2) TO 12;
                SUM = SUM + SIGN * R[AA] * TEMPABS[A+(13-AA)];
            END; /* END AA */

            DER[ A] = SUM / R[14];
        END; /* END A */

        DO X = 1 TO &MAXINDEX;
            TEMPABS[X] = DER[X];
        END; /* END X */

        IF &TABLEINDEX = 1 THEN IDERIVAT = 'SG1';
        ELSE IF &TABLEINDEX = 2 THEN IDERIVAT = 'SG2';
        ELSE IF &TABLEINDEX = 3 THEN IDERIVAT = 'SG3';
        ELSE IF &TABLEINDEX = 4 THEN IDERIVAT = 'SG4';
        ELSE IF &TABLEINDEX = 5 THEN IDERIVAT = 'SG5';
        ELSE IF &TABLEINDEX = 6 THEN IDERIVAT = 'SG6';
        ELSE IF &TABLEINDEX = 7 THEN IDERIVAT = 'SG7';
        ELSE IF &TABLEINDEX = 8 THEN IDERIVAT = 'SG8';
        ELSE IF &TABLEINDEX = 9 THEN IDERIVAT = 'SG9';
        ELSE IF &TABLEINDEX = 10 THEN IDERIVAT = 'SG10';
        IGAPS = LINECOUNTER;
        IFIRST = NEWSTART;
        ILAST = NEWEND;

        IF (&TABLEINDEX = 2 OR &TABLEINDEX = 5 OR &TABLEINDEX = 7) THEN DO;
            IF (LINECOUNTER ^= 1) THEN DO;
                OUTPUT;
                KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
            END; /* END LINECOUNTER DO */
        END;  /* END IF & TABLEINDEX = */

        ELSE DO;
             OUTPUT;
             KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
        END; /* END ELSE */

        %IF ((&TABLEINDEX = 2 OR &TABLEINDEX = 5 OR &TABLEINDEX = 7) AND LINECOUNTER ^= 1) OR
            (&TABLEINDEX ^=2 AND &TABLEINDEX ^=5 AND &TABLEINDEX ^=7)  %THEN %DO;
            PROC APPEND BASE = SAVITSKYDERIVATIVES DATA = FINSAVITSKY FORCE;
        %END;
    %END; /* END LINEINDEX1*/
%END; /* END TABLENUM*/

DATA SAVITSKYDERIVATIVES; SET SAVITSKYDERIVATIVES;
IF IDERIVAT = 'NON' THEN DELETE;
RUN;

DATA COMBINED; SET COMBINED;
DROP _ALL_;
DATA FINSAVITSKY; SET FINSAVITSKY;
DROP _ALL_;
DATA CONVOLUTE; SET CONVOLUTE;
DROP _ALL_;
DATA T_CHOSENTABLE; SET T_CHOSENTABLE;
DROP _ALL_;
DATA CHOSENTABLE; SET CHOSENTABLE;
DROP _ALL_;
DATA INSAVITSKY; SET INSAVITSKY;
DROP _ALL_;
DATA SAVGOL; SET SAVGOL;
DROP _ALL_;
RUN;

%END; /*IF SGYESNO = YES*/

%DERIVATIVES;

%MEND GAPSGDERIVATIVES;


%MACRO DERIVATIVES;

DATA FIRST; SET WORKFILE;
ARRAY FIRST[&FINALCOUNT1ST];
ARRAY LAST[&FINALCOUNT1ST];
ARRAY FORM[&FINALCOUNT1ST] $ ;
ARRAY MCVS[&FINALCOUNT1ST] $;
ARRAY GAPS[&FINALCOUNT1ST];
ARRAY DERIVAT[&FINALCOUNT1ST] $ ;

DO I = 1 TO &FINALCOUNT1ST;
    DERIVAT[I] = '1ST';
END;

DO I = 1 TO &FINALCOUNT1ST;
    FORM[I] = IFORM;
    MCVS[I] = IMCVS;
END;

GAP = &STARTGAP1ST;
START = IFIRST;
FINAL = ILAST;
ARRAY TEMP[&MAXINDEX];
ARRAY DER[&FINALCOUNT1ST,&MAXINDEX];
ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &FINALCOUNT1ST;
    DO J = 1 TO &MAXINDEX;
        DER[I,J]= TEMPABS[J];
    END; /* END J LOOP */
END; /* END I LOOP */

COUNTER = 0;

DO UNTIL (GAP >= &ENDGAP1ST);
    COUNTER = COUNTER + 1;

    IF &ODDEVENGAPS  = 'EVEN' THEN GAP = GAP*2;
    ELSE IF &ODDEVENGAPS = 'ODD' THEN DO;
        IF GAP = 1 THEN GAP = 2;
        IF GAP = 0.5 THEN GAP = 1;
        GAP = GAP*2 - 1;
    END; /* END ELSE DO */

    GAPS[COUNTER] = GAP;

    DO K = (GAP+START) TO (FINAL-GAP);
        TEMP[K] = DER[COUNTER,K+GAP] - DER[COUNTER,K-GAP];
    END; /* END K LOOP */

    DO L = 1 TO (START + GAP - 1);
        TEMP[L] =  TEMP[START + GAP];
    END;  /* END L LOOP */

    DO M = (FINAL-GAP+1) TO &MAXINDEX;
        TEMP[M] = TEMP[FINAL-GAP];
    END;  /* END M LOOP */

    FIRST[COUNTER] = START;
    LAST[COUNTER] = FINAL;

    DO P = 1 TO &MAXINDEX;
        DER[COUNTER, P] = TEMP[P];
    END; /* END OF P LOOP */
END; /* DO UNTIL END */

DO I = 1 TO &FINALCOUNT1ST;
    IDERIVAT = DERIVAT[I];
    IFORM = FORM[I];
    IMCVS = MCVS[I];
    IGAPS = GAPS[I];
    IFIRST = FIRST[I];
    ILAST = LAST[I];

    DO J = 1 TO &MAXINDEX;
        TEMPABS[J] = DER[I,J];
    END; /* END J LOOP */

    OUTPUT;
    KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
END; /* END I LOOP */
RUN;

DATA SECOND; SET WORKFILE;
ARRAY FIRST[&FINALCOUNT2ND];
ARRAY LAST[&FINALCOUNT2ND];
ARRAY FORM [&FINALCOUNT2ND] $ ;
ARRAY MCVS[&FINALCOUNT2ND] $;
ARRAY GAPS[&FINALCOUNT2ND];
ARRAY DERIVAT[&FINALCOUNT2ND] $ ;

DO I = 1 TO &FINALCOUNT2ND;
    DERIVAT[I] = '2ND';
END;

DO I = 1 TO &FINALCOUNT2ND;
    FORM[I] = IFORM;
    MCVS[I] = IMCVS;
END;

GAP = &STARTGAP2ND;
START=IFIRST;
FINAL = ILAST;
ARRAY TEMP[&MAXINDEX];
ARRAY DER[&FINALCOUNT2ND,&MAXINDEX];
ARRAY TEMPABS[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &FINALCOUNT2ND;
    DO J = 1 TO &MAXINDEX;
        DER[I,J]= TEMPABS[J];
    END; /* END J LOOP */
END; /* END I LOOP */

COUNTER = 0;

DO UNTIL (GAP = &ENDGAP2ND);
    COUNTER = COUNTER + 1;

    IF &ODDEVENGAPS  = 'EVEN' THEN GAP = GAP*2;
    ELSE IF &ODDEVENGAPS = 'ODD' THEN DO;
        IF GAP = 1 THEN GAP = 2;
        IF GAP = 0.5 THEN GAP = 1;
        GAP = GAP*2 - 1;
    END; /* END ELSE DO */

    GAPS[COUNTER] = GAP;

    DO K = (GAP+START) TO (FINAL-GAP);
        TEMP[K] = DER[COUNTER,K+GAP] - 2*DER[COUNTER,K] + DER[COUNTER,K-GAP];
    END; /* END K LOOP */

    DO L = 1 TO (START + GAP - 1);
        TEMP[L] = TEMP[GAP + START];
    END; /* END L LOOP */

    DO M = (FINAL-GAP+1) TO &MAXINDEX;
        TEMP[M] = TEMP[FINAL - GAP];
    END;   /* END M LOOP */

    FIRST[COUNTER] = START;
    LAST[COUNTER] = FINAL;

    DO P = 1 TO &MAXINDEX;
        DER[COUNTER, P] = TEMP[P];
    END; /* END OF P LOOP */
END; /* DO UNTIL END */

DO I = 1 TO &FINALCOUNT2ND;
    IDERIVAT = DERIVAT[I];
    IFORM = FORM[I];
    IMCVS = MCVS[I];
    IGAPS = GAPS[I];
    IFIRST = FIRST[I];
    ILAST = LAST[I];

    DO J = 1 TO &MAXINDEX;
        TEMPABS[J] =  DER[I,J];
    END; /* END J LOOP */

    OUTPUT;
    KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
END; /* END I LOOP */

RUN;

PROC APPEND BASE = WORKFILE DATA = FIRST FORCE;
PROC APPEND BASE = WORKFILE DATA = SECOND FORCE;

%IF &SGYESNO  =  "YES" %THEN %DO;
    PROC APPEND BASE = WORKFILE DATA = SAVITSKYDERIVATIVES FORCE;
%END; /* END IF */

RUN;

DATA WORKFILE; SET WORKFILE;
ARRAY TEMP[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO (IFIRST - 1);
    TEMP[I] = .;
END; /* I */

DO I = (ILAST + 1) TO &MAXINDEX;
    TEMP[I] = .;
END; /* END I */

DATA FIRST; SET FIRST;
DROP _ALL_;
DATA SECOND; SET SECOND;
DROP _ALL_;
DATA SAVITSKYDERIVATIVES; SET SAVITSKYDERIVATIVES;
DROP _ALL_;

%MEND DERIVATIVES;


%MACRO SKIPAVER;

DATA SKIPAVER; SET WORKFILE;
ARRAY ALLDATA[&MAXINDEX] ABS1-ABS&MAXINDEX;
ARRAY ASDATA[&MAXINDEX];

IF &AVSK = 'SKIP' THEN DO;
    SAVWAVES =  FLOOR ((ILAST-IFIRST)/&AVSKFACTOR);
    ALLDATA[1] = ALLDATA[IFIRST];

    DO I = 1 TO (SAVWAVES);
        ALLDATA[I+1] = ALLDATA[IFIRST + I*&AVSKFACTOR];
    END; /* END I LOOP */

    ILAST = SAVWAVES + 1;
    IFIRST = 1;
END; /* END SKIP IF LOOP */

IF &AVSK = 'AVER' THEN DO;
    SAVWAVES = FLOOR ((ILAST-IFIRST + 1)/&AVSKFACTOR);
    COUNTER = IFIRST-1;
    REMAINDER = (ILAST - IFIRST + 1) - SAVWAVES*&AVSKFACTOR;

    DO I = 1 TO (SAVWAVES);
        ASDATA[I] = 0;

        DO J = 1 TO &AVSKFACTOR;
            COUNTER = COUNTER + 1;
            ASDATA[I] = ASDATA[I] + ALLDATA[COUNTER];
        END;  /* END J LOOP */

        ALLDATA[I] = ASDATA[I]/&AVSKFACTOR;
        IFIRST = 1;
    END; /* I LOOP */

    IF REMAINDER > 0 THEN DO;
        SAVWAVES = SAVWAVES + 1;
        ASDATA[SAVWAVES] = 0;

        DO K = 1 TO REMAINDER;
            COUNTER = COUNTER + 1;
            ASDATA[SAVWAVES] = ASDATA[SAVWAVES] + ALLDATA[COUNTER];
        END; /* END K LOOP */

        ALLDATA[SAVWAVES] = ASDATA[SAVWAVES]/REMAINDER;
    END; /* END IF DO LOOP */

    ILAST = SAVWAVES;
END; /* END IF DO LOOP */

IF ILAST < &MAXINDEX THEN;

    DO L = (ILAST + 1) TO &MAXINDEX;
        ALLDATA[L] = 0.0;
    END; /* END DO L */

PROC SORT DATA = SKIPAVER;
    BY IDERIVAT IFORM IMCVS IGAPS;

DATA WORKFILE; SET SKIPAVER;
ARRAY TEMP[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO (IFIRST - 1);
    TEMP[I] = .;
END;

DO I = (ILAST + 1) TO &MAXINDEX;
    TEMP[I] = .;
END;

%LET MAXINDEX = %SYSEVALF(&MAXINDEX/&AVSKFACTOR, CEIL); /* STORAGE ONLY LIMITS */

DATA WORKFILE; SET WORKFILE;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
DATA SKIPAVER; SET SKIPAVER;
DROP _ALL_;
RUN;

%MEND SKIPAVER;


%MACRO MSCSNV;

%LET MINVARLIST =&CHEMS ABS1-ABS&MAXINDEX;
%LET MANALYTES = &CHEMS;

%IF &MSCYESNO  =  "YES" %THEN %DO;

DATA FORMSC; SET WORKFILE;
        IF (CHEMANALYTES1-CHEMANALYTES&MAXVARS)EQ . THEN DELETE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

PROC MEANS DATA = FORMSC NOPRINT;                      /* COMPUTE MEAN SPECTRUM */
    BY IDERIVAT IFORM IMCVS IGAPS;
    VAR &MINVARLIST;
    OUTPUT OUT = MNSPEC
    MEAN =  &MINVARLIST;
RUN;

DATA MEANSPEC; SET MNSPEC;
PROC TRANSPOSE DATA = MNSPEC OUT = AVERSPEC  PREFIX = MEANABS NAME=PKNUM;
    BY IDERIVAT IFORM IMCVS IGAPS;
    VAR ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS PKNUM;

                           /* COMPUTATION OF MSC DATA */
DATA ORGSPECS; SET WORKFILE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;
PROC TRANSPOSE DATA = ORGSPECS OUT = LORGSPEC PREFIX = ABSES NAME=PKNUM;
    BY IDERIVAT IFORM IMCVS IGAPS ID;
    VAR ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS PKNUM;

DATA MORGSPEC; MERGE LORGSPEC AVERSPEC;
    BY IDERIVAT IFORM IMCVS IGAPS PKNUM;
PROC SORT DATA = MORGSPEC;
    BY IDERIVAT IFORM IMCVS IGAPS ID PKNUM;

PROC REG DATA = MORGSPEC OUTEST = REGOUT NOPRINT;
    BY IDERIVAT IFORM IMCVS IGAPS ID;
    MODEL ABSES1 = MEANABS1;
RUN;

DATA REGOUT; SET REGOUT;
SLOPE = MEANABS1;
INTERCEPT = INTERCEPT;
DROP MEANABS1 ABSES1;
PROC SORT;
    BY IDERIVAT IFORM IMCVS IGAPS ID;

DATA ORGSPECS; SET ORGSPECS;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

DATA FINALMSC; MERGE ORGSPECS REGOUT; BY IDERIVAT IFORM IMCVS IGAPS ID;
IFORM =  'MSC';

DATA FINALMSC; SET FINALMSC;
ARRAY MSCABS[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    MSCABS[I] = (MSCABS[I] - INTERCEPT) /SLOPE;
END;

KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
RUN;

%END; /*IF MSC = YES */


%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "SNV") %THEN %DO;

DATA FINALSNV; SET WORKFILE;
ARRAY MNARRAY[&MAXINDEX] ABS1 - ABS&MAXINDEX;
ARRAY SQARRAY[&MAXINDEX];
MNSPEC= 0;

DO I = IFIRST TO ILAST;
    MNSPEC = MNSPEC + MNARRAY[I];
END; /* END DO I */

MNSPEC = MNSPEC/(ILAST - IFIRST + 1);

DO I = IFIRST TO ILAST;
    MNARRAY[I] = MNARRAY[I]- MNSPEC;
END; /* END DO I */

DO I = IFIRST TO ILAST;
    SQARRAY[I] = MNARRAY[I]*MNARRAY[I];
END; /* END DO I */

MNSUM = 0;

DO I = IFIRST TO ILAST;
    MNSUM = MNSUM + SQARRAY[I];
END; /* END DO I */

SQRTMNSUM = SQRT(MNSUM/(ILAST - IFIRST));

DO I = IFIRST TO ILAST;
    MNARRAY[I] = MNARRAY[I] / SQRTMNSUM;
END; /* END DO I */

DATA FINALSNV; SET FINALSNV;
ARRAY FORM[1] $ IFORM;
FORM[1] = 'SNV';

KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%END; /* IF BOTH OR SNV */


%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "DET") %THEN %DO;

DATA FINALDETREND; SET FINALSNV;
ARRAY FORM[1] $ IFORM;
FORM[1] = 'DET';

PROC SORT DATA = FINALDETREND;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

PROC TRANSPOSE DATA = FINALDETREND OUT = TRANSSNV PREFIX = ABSORB NAME = PKNUM;
    BY ID IDERIVAT IFORM IMCVS IGAPS;
    VAR ABS1-ABS&MAXINDEX;

DATA ALL; SET TRANSSNV;
N = _N_;
X = FLOOR ((N - 1)/&MAXINDEX);
I = N - X*&MAXINDEX;
II = I*I;

PROC REG OUTEST = OUTALL NOPRINT; BY ID IDERIVAT IFORM IMCVS IGAPS;
    MODEL ABSORB1 = I II;
RUN;

DATA OUTALL; SET OUTALL;
INTERCEPT = INTERCEPT;
COEFF1 = I;
COEFF2 = II;
DROP I II _MODEL_ _TYPE_ _DEPVAR_ _RMSE_ ABSORB1;
PROC SORT DATA = OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA NEWALL; MERGE FINALDETREND OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA COMPUTED; SET NEWALL;
ARRAY DTARRAY[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    II = I*I;
    DTARRAY[I] = DTARRAY[I] - (INTERCEPT + I*COEFF1 + II*COEFF2);
END; /* END DO I */

DATA DETREND; SET COMPUTED;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%END; /*IF BOTH OR DET ONLY */

%IF &DETONLY =  "YES" %THEN %DO;

DATA FINALDETREND; SET WORKFILE;
ARRAY FORM[1] $ IFORM;
FORM[1] = 'DTO';

PROC SORT DATA = FINALDETREND;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

PROC TRANSPOSE DATA = FINALDETREND OUT = TRANSSNV PREFIX = ABSORB NAME = PKNUM;
    BY ID IDERIVAT IFORM IMCVS IGAPS;
    VAR ABS1-ABS&MAXINDEX;

DATA ALL; SET TRANSSNV;
N = _N_;
X = FLOOR ((N - 1)/&MAXINDEX);
I = N - X*&MAXINDEX;
II = I*I;

PROC REG OUTEST = OUTALL NOPRINT; BY ID IDERIVAT IFORM IMCVS IGAPS;
    MODEL ABSORB1 = I II;
RUN;

DATA OUTALL; SET OUTALL;
INTERCEPT = INTERCEPT;
COEFF1 = I;
COEFF2 = II;
DROP I II _MODEL_ _TYPE_ _DEPVAR_ _RMSE_ ABSORB1;
PROC SORT DATA = OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA NEWALL; MERGE FINALDETREND OUTALL;
    BY ID IDERIVAT IFORM IMCVS IGAPS;

DATA COMPUTED; SET NEWALL;
ARRAY DTARRAY[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    II = I*I;
    DTARRAY[I] = DTARRAY[I] - (INTERCEPT + I*COEFF1 + II*COEFF2);
END; /* END DO I */

DATA DETRENDONLY; SET COMPUTED;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%END; /*IF DETONLY */


DATA COMBINED; SET WORKFILE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS ID;

%IF &MSCYESNO  =  "YES" %THEN %DO;
    PROC APPEND BASE = COMBINED DATA=FINALMSC FORCE;
%END;

%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "SNV") %THEN %DO;
    PROC APPEND BASE = COMBINED DATA = FINALSNV FORCE;
%END;

%IF (&SNVDETYESNO  =  "BOTH") OR (&SNVDETYESNO  =  "DET") %THEN %DO;
    PROC APPEND BASE = COMBINED DATA = DETREND FORCE;
%END;

%IF (&DETONLY =  "YES") %THEN %DO;
    PROC APPEND BASE = COMBINED DATA = DETRENDONLY FORCE;
%END;

DATA WORKFILE; SET COMBINED;
RUN;
DATA ORGSPECS; SET ORGSPECS;
DROP _ALL_;
DATA REGOUT; SET REGOUT;
DROP _ALL_;
DATA MORGSPEC; SET MORGSPEC;
DROP _ALL_;
DATA LORGSPEC; SET LORGSPEC;
DROP _ALL_;
DATA AVERSPEC; SET AVERSPEC;
DROP _ALL_;
DATA MEANSPEC; SET MEANSPEC;
DROP _ALL_;
DATA MNSPEC; SET MNSPEC;
DROP _ALL_;
DATA TRANSSNV; SET TRANSSNV;
DROP _ALL_;
DATA FINALDETREND; SET FINALDETREND;
DROP _ALL_;
DATA ALL; SET ALL;
DROP _ALL_;
DATA OUTALL; SET OUTALL;
DROP _ALL_;
DATA NEWALL; SET NEWALL;
DROP _ALL_;
DATA COMPUTED; SET COMPUTED;
DROP _ALL_;
DATA DETREND; SET DETREND;
DROP _ALL_;
DATA COMBINED; SET COMBINED;
DROP _ALL_;
DATA FINALSNV; SET FINALSNV;
DROP _ALL_;
DATA FINALMSC; SET FINALMSC;
DROP _ALL_;
RUN;

%MEND MSCSNV;


%MACRO MEANCENTERVARSCALED;

%LET MINVARLIST = &CHEMS ABS1-ABS&MAXINDEX;
%LET MEANVARS = MCHEMS1-MCHEMS&MAXVARS MABS1-MABS&MAXINDEX;
%LET STDVARS = SCHEMS1-SCHEMS&MAXVARS SABS1-SABS&MAXINDEX;
%LET VARLIST = &PRTANALYTES ABS1 - ABS&MAXINDEX;   /* NEEDED AS WRITTEN HERE */
%LET MCVARS = ID  MCCHEMS1-MCCHEMS&MAXVARS MCABS1 - MCABS&MAXINDEX;
%LET VSVARS =  ID  VSCHEMS1-VSCHEMS&MAXVARS VSABS1 - VSABS&MAXINDEX;

DATA MSVAR; SET WORKFILE;
IF CHEMANALYTES1 EQ  . THEN DELETE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS;

PROC MEANS DATA = MSVAR NOPRINT;
    BY  IDERIVAT IFORM IMCVS IGAPS;
    VAR &MINVARLIST;
    OUTPUT OUT = MCVARSCALED
    MEAN =  &MEANVARS STD = &STDVARS;
PROC SORT DATA=MCVARSCALED;
    BY  IDERIVAT IFORM IMCVS IGAPS;

DATA WORKFILE; SET WORKFILE;
PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS;

DATA MERGEDMSVARMCVARSCALED;
MERGE WORKFILE MCVARSCALED;
    BY  IDERIVAT IFORM IMCVS IGAPS;

DATA MEANCENTERED; SET MERGEDMSVARMCVARSCALED;
ARRAY MCARRABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
ARRAY MARRABS[&MAXINDEX] MABS1-MABS&MAXINDEX;
ARRAY CENTEREDCHEMS[&MAXVARS] &CHEMS;
ARRAY MEANCHEMS[&MAXVARS] MCHEMS1 - MCHEMS&MAXVARS;

DO I = IFIRST TO ILAST;
    MCARRABS[I] = MCARRABS[I] - MARRABS[I];
END; /* END I LOOP */

DO I = 1 TO &MAXVARS;
    CENTEREDCHEMS[I] = CENTEREDCHEMS[I] - MEANCHEMS[I];
END;  /*END I LOOP*/

IMCVS = 'MCN';

DATA VARSCALED; SET MERGEDMSVARMCVARSCALED;
ARRAY VSARRABS[&MAXINDEX] ABS1-ABS&MAXINDEX;
ARRAY MARRABS[&MAXINDEX] MABS1-MABS&MAXINDEX;
ARRAY SARRABS[&MAXINDEX] SABS1-SABS&MAXINDEX;
ARRAY VSCHEMS[&MAXVARS] CHEMANALYTES1-CHEMANALYTES&MAXVARS;
ARRAY MEANCHEMS[&MAXVARS] MCHEMS1 - MCHEMS&MAXVARS;
ARRAY STDCHEMS[&MAXVARS] SCHEMS1 - SCHEMS&MAXVARS;

DO I = IFIRST TO ILAST;
    IF SARRABS[I] ^= 0.0 THEN
        VSARRABS[I] = (VSARRABS[I] - MARRABS[I])  / SARRABS[I];
        ELSE
            VSARRABS[I] = 0.0;
END; /* END I LOOP */

DO I = 1 TO &MAXVARS;
    IF STDCHEMS[I] ^= 0.0 THEN
       VSCHEMS[I] = (VSCHEMS[I] - MEANCHEMS[I]) / STDCHEMS[I];
        ELSE
           VSCHEMS[I] = 0.0;
END;  /*END I LOOP*/

IMCVS = 'VSC';
OUTPUT;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;

DATA SAVVARIANCES; SET MERGEDMSVARMCVARSCALED;
IF ID = &FIRSTFILE;
KEEP IDERIVAT IFORM IMCVS IGAPS SCHEMS1-SCHEMS&MAXVARS;

%IF &MCOPTION = "PRO" %THEN %DO;

DATA MEANCENTERED; SET MEANCENTERED;
OUTPUT;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;


PROC APPEND BASE = WORKFILE DATA = MEANCENTERED FORCE;
PROC APPEND BASE = WORKFILE DATA  = VARSCALED FORCE;

%END; /* END IF MCOPTION = PRO */

DATA MSVAR; SET MSVAR;
DROP _ALL_;
DATA MCVARSCALED; SET MCVARSCALED;
DROP _ALL_;
DATA MERGEDMSVARMCVARSCALED; SET MERGEDMSVARMCVARSCALED;
DROP _ALL_;
DATA MEANCENTERED; SET MEANCENTERED;
DROP _ALL_;
DATA VARSCALED; SET VARSCALED;
DROP _ALL_;
RUN;

%MEND MEANCENTERVARSCALED;


%MACRO PREPAREFORPLS;
DATA WORKFILE; SET WORKFILE;
ARRAY SPECTRA[&MAXINDEX] ABS1-ABS&MAXINDEX;

DO I = 1 TO &MAXINDEX;
    IF SPECTRA[I] = . THEN SPECTRA[I] = 0.0;
END; /* END DO I */

PROC SORT DATA = WORKFILE;
    BY IDERIVAT IFORM IMCVS IGAPS;

DATA WORKFILE; SET WORKFILE;
OUTPUT;
KEEP IDERIVAT IFORM IMCVS IGAPS IFIRST ILAST &PRTANALYTES ABS1-ABS&MAXINDEX;

%MEND PREPAREFORPLS;

%MACRO PRINTCORRELATIONPLOTS;

DATA TEST; SET WORKFILE;


%DO VARX = 1 %TO &MAXVARS;

PROC CORR DATA = TEST OUT = T_CORR NOPRINT; BY IDERIVAT IFORM IMCVS IGAPS;
VAR ABS1-ABS&MAXINDEX; WITH CHEMANALYTES&VARX ;
RUN;

DATA T_CORR; SET T_CORR;
IF _TYPE_ = "CORR";
DROP _TYPE_;
RUN;

DATA SAVECORR; SET T_CORR;
ARRAY CORRS[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVCORRPLOT.TXT";
DO I = 1 TO &MAXINDEX;
PUT _NAME_ $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRS[I];
END;
RUN;



DATA FORGPLOT; INFILE "SAVCORRPLOT.TXT";
INPUT  NAME $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRELATION;
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
WN =I*FACTOR + &LASTWN - FACTOR;
RUN;

DATA FORGPLOT; SET FORGPLOT;
RSQUARE = CORRELATION*CORRELATION;
I = -I;
WN = - WN;

PROC PRINTTO;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN, FLOOR);
%LET LASTWN = %SYSEVALF(&LASTWN, FLOOR);

AXIS1 ORDER = (-&FIRSTWN TO - &LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'CORRELATION')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

AXIS3 LABEL = (FONT = SWISSB ANGLE = 90 'RSQUARE')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;


SYMBOL I=JOIN LINE = 1 WIDTH = 10 C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
FORMAT WN REVERSE.;
BY NAME IDERIVAT IFORM IMCVS IGAPS;
PLOT CORRELATION * WN/ HAXIS = AXIS1 VAXIS = AXIS2;
PLOT RSQUARE * WN/ HAXIS = AXIS1 VAXIS = AXIS3;
%END;
%MEND;


%MACRO PRINTSPECTRALPLOTS;

DATA TEST; SET FORPLOTTING;
ABS&MAXINDEX = .;
ABS1 = .;

DATA SAVESPECTRA; SET TEST;
ARRAY SPECTRUM[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVSPECTRA.TXT";
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
DO I = 1 TO &MAXINDEX;
WN = I*FACTOR + &LASTWN - FACTOR;
PUT ID $ I WN SPECTRUM[I];
END;
RUN;

DATA FORGPLOT; INFILE "SAVSPECTRA.TXT";
INPUT ID $ I WN ABSORBANCE;
I = -I;
WN = - WN;
RUN;

PROC SORT DATA = FORGPLOT;
BY ID I;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN);
%LET LASTWN = %SYSEVALF(&LASTWN, CEIL);

AXIS1 ORDER = (-&FIRSTWN TO -&LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER =4)
            MINOR = (WIDTH = 10 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'ABSORBANCE')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL LINE = 1 WIDTH = 10 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
       FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;


GOPTION LFACTOR = 1;
RUN;
SYMBOL LINE = 1 WIDTH = 10 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
BY ID;
FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;

%MEND;


%MACRO VIEWCORRELATIONPLOTS;

DATA TEST; SET WORKFILE;

%DO VARX = 1 %TO &MAXVARS;
PROC CORR DATA = TEST OUT = T_CORR NOPRINT; BY IDERIVAT IFORM IMCVS IGAPS;
VAR ABS1-ABS&MAXINDEX; WITH CHEMANALYTES&VARX ;
RUN;

DATA T_CORR; SET T_CORR;
IF _TYPE_ = "CORR";
DROP _TYPE_;
RUN;

DATA SAVECORR; SET T_CORR;
ARRAY CORRS[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVCORRPLOT.TXT";
DO I = 1 TO &MAXINDEX;
PUT _NAME_ $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRS[I];
END;
RUN;



DATA FORGPLOT; INFILE "SAVCORRPLOT.TXT";
INPUT  NAME $ 15. IDERIVAT $ IFORM $ IMCVS $ IGAPS I CORRELATION;
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
WN =I*FACTOR + &LASTWN - FACTOR;
RUN;

DATA FORGPLOT; SET FORGPLOT;
RSQUARE = CORRELATION*CORRELATION;
I = -I;
WN = - WN;

PROC PRINTTO;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN, FLOOR);
%LET LASTWN = %SYSEVALF(&LASTWN, FLOOR);

AXIS1 ORDER = (-&FIRSTWN TO - &LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'CORRELATION')
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);

AXIS3 LABEL = (FONT = SWISSB ANGLE = 90 'RSQUARE')
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL I=JOIN LINE = 1 WIDTH = 1 C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
FORMAT WN REVERSE.;
BY NAME IDERIVAT IFORM IMCVS IGAPS;
PLOT CORRELATION*WN/ HAXIS = AXIS1
VAXIS = AXIS2;
PLOT RSQUARE*WN/ HAXIS = AXIS1
VAXIS = AXIS3;
%END;
%MEND;


%MACRO VIEWSPECTRALPLOTS;

DATA TEST; SET FORPLOTTING;
ABS&MAXINDEX = .;
ABS1 = .;

DATA SAVESPECTRA; SET TEST;
ARRAY SPECTRUM[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVSPECTRA.TXT";
FACTOR = (&FIRSTWN - &LASTWN)/&MAXINDEX;
DO I = 1 TO &MAXINDEX;
WN = I*FACTOR + &LASTWN - FACTOR;
PUT ID $ IDERIVAT $ IFORM $ IMCVS $ IGAPS I WN SPECTRUM[I] FACTOR;
END;
RUN;

DATA FORGPLOT; INFILE "SAVSPECTRA.TXT";
INPUT ID $ IDERIVAT $ IFORM $ IMCVS $ IGAPS I WN ABSORBANCE;
I = -I;
WN = - WN;
RUN;

PROC SORT DATA = FORGPLOT;
BY IDERIVAT IFORM IMCVS IGAPS ID I;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN);
%LET LASTWN = %SYSEVALF(&LASTWN, CEIL);

AXIS1 ORDER = (-&FIRSTWN TO -&LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER =4)
            MINOR = (WIDTH = 1 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'ABSORBANCE')
            WIDTH = 1
            MAJOR = (WIDTH = 1 NUMBER = 8)
            MINOR = (WIDTH = 1 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL LINE = 1 WIDTH = 1 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
       FORMAT WN REVERSE.;
           BY IDERIVAT IFORM IMCVS IGAPS;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;


GOPTION LFACTOR = 1;
RUN;
SYMBOL LINE = 1 WIDTH = 1 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
BY IDERIVAT IFORM IMCVS IGAPS ID;
FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS = AXIS1
VAXIS = AXIS2;

%MEND;

%MACRO PRINTLIMITEDSPECTRALPLOTS;

DATA TEST; SET LIMITED;

DATA SAVESPECTRA; SET TEST;
ARRAY SPECTRUM[&MAXINDEX] ABS1-ABS&MAXINDEX;
FILE "SAVSPECTRA.TXT";
FACTOR = (&FIRSTWN - &LASTWN) / (&MAXINDEX);
DO I = 1 TO &MAXINDEX;
WN = I*FACTOR + &LASTWN - FACTOR;
PUT ID $ I WN SPECTRUM[I];
END;
RUN;

DATA FORGPLOT; INFILE "SAVSPECTRA.TXT";
INPUT ID $ I WN ABSORBANCE;
I = -I;
WN = - WN;
RUN;

PROC SORT DATA = FORGPLOT;
BY ID I;
RUN;

PROC FORMAT ;
PICTURE  REVERSE
LOW - < 0  = '0999'
0 < - HIGH = '0999' (PREFIX = '-')
0                = '0999';
RUN;

%LET FIRSTWN = %SYSEVALF(&FIRSTWN, FLOOR);
%LET LASTWN = %SYSEVALF(&LASTWN, FLOOR);

AXIS1 ORDER = (-&FIRSTWN TO -&LASTWN BY &BYFACTOR)
            LABEL = (FONT = SWISSB 'WAVELENGTH NM' )
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER =4)
            MINOR = (WIDTH = 10 NUMBER = 10);
AXIS2 LABEL = (FONT = SWISSB ANGLE = 90 'ABSORBANCE')
            WIDTH = 10
            MAJOR = (WIDTH = 10 NUMBER = 8)
            MINOR = (WIDTH = 10 NUMBER = 10);

GOPTION LFACTOR = 1 FTEXT = SWISSB;
RUN;
SYMBOL LINE = 1 WIDTH = 10 I=JOIN C=BLACK V=NONE;
PROC GPLOT DATA = FORGPLOT;
       FORMAT WN REVERSE.;
PLOT ABSORBANCE*WN/OVERLAY SKIPMISS HAXIS =
AXIS1
VAXIS = AXIS2;

%MEND;



%MACRO PLSMACRO;

DATA PREDICTACTUAL;
ID = '        ';
CHEM = .;
IDLABEL = '        ';
IDERIVAT = '        ';
IFORM = '        ';
IMCVS = '        ';
IGAPS = .;
CALVAL ='   ';
%DO W = &FIRSTCLASS %TO &LASTCLASS;
    P_CHEMANALYTES&W = .;
        OANALYTE&W = .;
        CHEMANALYTES&W = .;
%END;
RUN;


    ODS LISTING CLOSE;
    OPTION LINESIZE = 120;
    ODS OUTPUT "RESIDUAL SUMMARY" = PRESS_RESULTS;

    %IF &MCOPTION = "PRO" %THEN %DO;
        PROC PLS DATA=WORKFILE METHOD=&METHOD NOCENTER NOSCALE CV=&CV /*RANDOM (NITER=100 NTEST=10)*/ CVTEST (PVAL=0.25 SEED=1234);
            BY IDERIVAT IFORM IMCVS IGAPS;
            MODEL CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = SASPREDCHEMANALYTE     P = P_CHEMANALYTES&FIRSTCLASS-P_CHEMANALYTES&LASTCLASS XSCORE = T;
            RUN;
    %END; /* END MCOPTION = PRO */

    %ELSE %IF &MCOPTION = "SAS" %THEN %DO;
            PROC PLS DATA = WORKFILE METHOD = &METHOD CV = &CV /*RANDOM (NITER = 100 NTEST = 10) */ CVTEST (PVAL=0.25 SEED=1234);
            BY IDERIVAT IFORM IMCVS IGAPS;
            MODEL CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = SASPREDCHEMANALYTE P = P_CHEMANALYTES&FIRSTCLASS-P_CHEMANALYTES&LASTCLASS XSCORE = T;
            RUN;
         %END; /* END MCOPTION = SAS */

    %ELSE %DO;
        PROC PLS DATA=WORKFILE METHOD=&METHOD NOCENTER NOSCALE CV=&CV /*RANDOM (NITER=100 NTEST=10)*/ CVTEST (PVAL=0.25 SEED=1234);
            BY IDERIVAT IFORM IMCVS IGAPS;
            MODEL CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = SASPREDCHEMANALYTE P = P_CHEMANALYTES&FIRSTCLASS-P_CHEMANALYTES&LASTCLASS XSCORE = T;
            RUN;
     %END; /* END MCOPTION = NON */

    ODS OUTPUT CLOSE;
    ODS LISTING;


    DATA VALIDAT;
    INFILE "&VALIDATIONFILE";
    INPUT ID $ IDLABEL $ OANALYTE1 - OANALYTE&MAXVARS;
    RUN;

    PROC SORT DATA = VALIDAT;
      BY ID;
    RUN;

    DATA NEWPRED; SET SASPREDCHEMANALYTE;
    IF CHEMANALYTES&FIRSTCLASS NE  . THEN DELETE;
    PROC SORT; BY ID;

    DATA ORIGPRED; MERGE VALIDAT NEWPRED;
        BY ID;

    PROC SORT DATA = ORIGPRED;
        BY  IDERIVAT IFORM IMCVS IGAPS;


%DO X = &FIRSTCLASS %TO &LASTCLASS;

     DATA SUMCALVAL;
     _TYPE_ = '.';
     _NAME_ = '.';
    SDIF = .;
    SDSQ = .;
    PRESS = .;
    SEP = .;
    SEPC = .;
    BIAS = .;
    RMSD = .;
    VPRESS = .;
    VSEP = .;
    VSEPC = .;
    VBIAS = .;
    VRMSD = .;
    %DO Y = &FIRSTCLASS %TO &LASTCLASS;
             CHEMANALYTES&Y = .;
             OANALYTE&Y = .;
    %END;
    RUN;

    PROC CORR DATA = ORIGPRED OUT = PREVALIDATION NOPRINT;
        VAR OANALYTE&X;  WITH P_CHEMANALYTES&X;
        BY IDERIVAT IFORM IMCVS IGAPS;
        RUN;

    DATA SQUAREDVALIDATION; SET PREVALIDATION;
    IF _TYPE_ = 'CORR' THEN
        OANALYTE&X = OANALYTE&X*OANALYTE&X;
    ELSE
         DELETE;

    PROC SORT DATA = SQUAREDVALIDATION;
        BY IDERIVAT IFORM IMCVS IGAPS;

    TITLE "RESULTS OF PLS THE SAS WAY - MC + VS BY PROGRAM ONLY METHOD = &METHOD ANALYTE = &X";

    PROC CORR DATA = SASPREDCHEMANALYTE OUT = ACOUTCHEMANALYTE NOPRINT;
        BY IDERIVAT IFORM IMCVS IGAPS;
        VAR CHEMANALYTES&X; WITH P_CHEMANALYTES&X;
        RUN;

    DATA SQUARED; SET ACOUTCHEMANALYTE;
         IF _TYPE_ = 'CORR' THEN
              CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
         ELSE
              DELETE;

    PROC SORT DATA = SQUARED;
         BY IDERIVAT IFORM IMCVS IGAPS;

    DATA SQUARED; MERGE SQUARED SQUAREDVALIDATION;
         BY IDERIVAT IFORM IMCVS IGAPS;
         RUN;

    DATA FINDFACTORS; SET SASPREDCHEMANALYTE;
    IF ID = &FIRSTFILE;   /* ID OF FIRST SPECTRA MUST BE SPECIFIED' */
    NUMFACTORS = 1;
    T16 =.;
    ARRAY XFACS[16] T1-T16;

    DO WHILE (XFACS[NUMFACTORS] NE .);
            NUMFACTORS = NUMFACTORS + 1;
    END; /* END DO WHILE */

    FACTOR = NUMFACTORS - 1;
    DROP CHEMANALYTES&X;

    PROC SORT DATA = FINDFACTORS;
        BY IDERIVAT IFORM IMCVS IGAPS;
    PROC SORT DATA = SQUARED;
        BY IDERIVAT IFORM IMCVS IGAPS;
    DATA SASWAY; MERGE SQUARED FINDFACTORS;
        BY IDERIVAT IFORM IMCVS IGAPS;

    PROC SORT DATA = SASWAY; BY CHEMANALYTES&X;
    PROC PRINT DATA = SASWAY;
         VAR IDERIVAT IFORM IMCVS IGAPS CHEMANALYTES&X  OANALYTE&X FACTOR;
    RUN;



    DATA SASWAY; SET SASWAY;
    FILE "&SASWAYOUTFILE" MOD LRECL=180;
        ANALYTEID = &X;
        PUT "&METHOD"  "   " ANALYTEID IDERIVAT $  IFORM $ IMCVS $ IGAPS CHEMANALYTES&X OANALYTE&X FACTOR;
        RUN;

    TITLE "GRAMS-LIKE CROSS VALIDATION RESULTS PRESS RESULTS - MC + VS BY PROGRAM ONLY METHOD = &METHOD ANALYTE = &X";

    PROC SORT DATA = PRESS_RESULTS;
        BY IDERIVAT IFORM IMCVS IGAPS;
    PROC MEANS NOPRINT DATA=PRESS_RESULTS;
        BY IDERIVAT IFORM IMCVS IGAPS;
        VAR ROOTMEANPRESS;
        OUTPUT OUT = GETTHEMIN MIN = MINROOTMEANPRESS;
        RUN;

    DATA MINPRESSVALUE; SET GETTHEMIN;
        MINPRESSVALUE = MINROOTMEANPRESS * MINROOTMEANPRESS * (&NUMFILES - 1);
        RUN;

    PROC SORT DATA = MINPRESSVALUE;
        BY IDERIVAT IFORM IMCVS IGAPS;
        RUN;

    DATA ADDCOMMONVAR;
        SET PRESS_RESULTS;
        PRESSVALUE = ROOTMEANPRESS * ROOTMEANPRESS * (&NUMFILES - 1);
        IF NUMBEROFFACTORS = 0 THEN DELETE;

    PROC SORT DATA = ADDCOMMONVAR;
        BY IDERIVAT IFORM IMCVS IGAPS;
        RUN;

    DATA GRAMSLIKETABLE;
        MERGE ADDCOMMONVAR MINPRESSVALUE;
        BY IDERIVAT IFORM IMCVS IGAPS;
        F_RATIO = PRESSVALUE / MINPRESSVALUE;
        F_TEST = CDF('F',F_RATIO,(&NUMFILES-1),(&NUMFILES-1));
        MINREC = 0;
        IF F_TEST <= 0.75 THEN MINREC = _N_;
        RUN;

    DATA GRAMSLIKETABLE; SET GRAMSLIKETABLE;
        IF MINREC = 0 THEN MINREC = .;

    PROC SORT DATA = GRAMSLIKETABLE;
        BY IDERIVAT IFORM IMCVS IGAPS;

    PROC MEANS NOPRINT DATA = GRAMSLIKETABLE;
        BY IDERIVAT IFORM IMCVS IGAPS;
        VAR MINREC;
        OUTPUT OUT = THEMINREC MIN = MINFAC;
        RUN;

    PROC SORT DATA = THEMINREC;
        BY IDERIVAT IFORM IMCVS IGAPS;
        RUN;

    DATA GRAMSTABLE;
        MERGE GRAMSLIKETABLE THEMINREC;
        BY IDERIVAT IFORM IMCVS IGAPS;
        IF _N_ > MINFAC THEN DO;
        F_RATIO = .;
        F_TEST = .;
    END; /* END IF DO */

    RUN;

    PROC SORT DATA = GRAMSTABLE;
        BY IDERIVAT IFORM IGAPS IMCVS;
    PROC SORT DATA = SAVVARIANCES;
        BY IDERIVAT IFORM IGAPS IMCVS;

    DATA NEWGRAMSTABLE;
        MERGE GRAMSTABLE SAVVARIANCES;
        BY IDERIVAT IFORM IGAPS;
    IF (IMCVS = 'VSC') OR ((&MCOPTION = "SAS") AND (&SCALE = "YES" )) THEN PRESSVALUE = PRESSVALUE*SCHEMS&X*SCHEMS&X;
    IF PRESSVALUE = . THEN PRESSVALUE = 999999999999;
    RUN;

    PROC SORT DATA = NEWGRAMSTABLE;
        BY IDERIVAT IFORM IMCVS IGAPS;
    RUN;


TITLE "SUMMARY OF GRAMS-LIKE CROSS VALIDATION RESULTS - MC + VS BY PROGRAM ONLY METHOD = &METHOD ANALYTE = &X";

    DATA SUMMARYOFGRAMS; SET NEWGRAMSTABLE;
    IF F_TEST = . THEN DELETE;
    IF F_TEST > 0.75 THEN DELETE;
    PROC SORT DATA = SUMMARYOFGRAMS;
        BY DESCENDING PRESSVALUE;
    PROC PRINT NOOBS DATA = SUMMARYOFGRAMS;
        VAR IDERIVAT IFORM IMCVS IGAPS NUMBEROFFACTORS PRESSVALUE F_RATIO F_TEST;
    RUN;


    DATA SUMMARYOFGRAMS; SET SUMMARYOFGRAMS;
    FILE "&OUTPUTFILE" MOD LRECL=180;
    PUT "&METHOD"  "  " IDERIVAT $ 1-6 IFORM $ 6-12 IMCVS $ 13-18 IGAPS 19-24 NUMBEROFFACTORS 25-30
    PRESSVALUE 31-42 .4 F_RATIO 43-50 .4 F_TEST 51-58 .4;
    RUN;

    DATA SUMMARY; SET SUMMARYOFGRAMS;
    PROC SORT; BY IDERIVAT IFORM IMCVS IGAPS;
    DATA TOTAL; MERGE WORKFILE SUMMARY;
         BY IDERIVAT IFORM IMCVS IGAPS;

    PROC FREQ DATA   = TOTAL;
       BY IDERIVAT IFORM IMCVS IGAPS;
          TABLES   NUMBEROFFACTORS
                   / NOPRINT
               OUT    = NUMBEROFFACTORS;


    DATA NUMBEROFFACTORS; SET NUMBEROFFACTORS;
        IF NUMBEROFFACTORS = . THEN NUMBEROFFACTORS = 1;
    FILE 'LIST.TXT';
    PUT IDERIVAT $ IFORM $ IMCVS $ IGAPS NUMBEROFFACTORS;
    RUN;


    OPTION NOXWAIT;
        X "&DIRECTORY\RECODPLS";
    RUN;
        PROC OPTIONS OPTION = SASAUTOS;
        RUN;

    %INCLUDE "&DIRECTORY\PLSTWOAF.SAS";


    %PLSTWOAF
    RUN;

    DATA SUMCALVAL; SET SUMCALVAL;
    IF _TYPE_ = '.' THEN DELETE;
    RUN;

    DATA SUMCALVALOUT; MERGE NUMBEROFFACTORS SUMCALVAL;
    CALR2 = CHEMANALYTES&X;
    VALR2 = OANALYTE&X;
    KEEP IDERIVAT IFORM IMCVS IGAPS NUMBEROFFACTORS SDIF SDSQ PRESS SEP SEPC BIAS RMSD
                 VPRESS VSEP VSEPC VBIAS VRMSD CALR2 VALR2;
        RUN;
    PROC SORT DATA = SUMCALVALOUT;
    BY CALR2;
    PROC PRINT;
        RUN;

     PROC DATASETS NOWARN;
     DELETE SUMCALVAL;
     RUN;


DATA PREDICTACTUAL; SET PREDICTACTUAL;
IF IFORM = '       ' THEN DELETE;
RUN;

DATA SUMCALVALOUT; SET SUMCALVALOUT;
FILE "&SUMCALVALOUTFILE" MOD;
ANALYTEID = &X;
PUT "&METHOD"  "   " ANALYTEID IDERIVAT $ IFORM $ IMCVS $ IGAPS NUMBEROFFACTORS
        SDIF SDSQ PRESS SEP SEPC BIAS RMSD  VPRESS VSEP VSEPC VBIAS VRMSD
        CALR2 VALR2;
RUN;

PROC SORT DATA = PREDICTACTUAL;
BY CALVAL IDERIVAT IFORM IMCVS IGAPS;
RUN;

DATA PRECAL; SET PREDICTACTUAL;
IF CALVAL = 'CAL';
FILE "&CALPRED";
PUT "&METHOD"  "   " ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS-P_CHEMANALYTES&LASTCLASS;
RUN;

DATA PREVAL; SET PREDICTACTUAL;
IF CALVAL = 'VAL';
FILE "&VALPRED";
PUT "&METHOD"  "   " ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS OANALYTE&FIRSTCLASS- OANALYTE&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
RUN;


%END; /* END X LOOP FOR PLS */;

    DATA SASPREDCHEMANALYTE; SET SASPREDCHEMANALYTE;
    DROP _ALL_;
    DATA ACOUTCHEMANALYTE; SET ACOUTCHEMANALYTE;
    DROP _ALL_;
    DATA SQUARED; SET SQUARED;
    DROP _ALL_;
    DATA FINDFACTORS; SET FINDFACTORS;
    DROP _ALL_;
    DATA SASWAY; SET SASWAY;
    DROP _ALL_;
    RUN;
    DATA PRESS_RESULTS; SET PRESS_RESULTS;
    DROP _ALL_;
    RUN;
    DATA ADDCOMMONVAR; SET ADDCOMMONVAR;
    DROP _ALL_;
    DATA MINPRESSVALUE; SET MINPRESSVALUE;
    DROP _ALL_;
    RUN;
    DATA GRAMSLIKETABLE; SET GRAMSLIKETABLE;
    DROP _ALL_;
    RUN;
    DATA GRAMSTABLE; SET GRAMSTABLE;
    DROP _ALL_;
    DATA NEWGRAMSTABLE; SET NEWGRAMSTABLE;
    DROP _ALL_;


%MEND PLSMACRO;



%GETSPECONE
RUN;
%GETCHEM
RUN;
/*
%ALTERNATEINPUTII
RUN;
*/
DATA CALIBRATION; SET WORKFILE;
IF CHEMANALYTES1 ^= .;

DATA CALIBRATION; SET CALIBRATION;
EXT = '.SPC';
FILE "&RCOMBINEDCALCFL";
PUT #1 ID $ EXT $;
PUT #2 CHEMANALYTES&FIRSTCLASS - CHEMANALYTES&LASTCLASS;
RUN;

DATA VALIDATION; SET VALIDATION;
EXT = '.SPC';
FILE "&RCOMBINEDVALCFL";
PUT #1 ID $  EXT $;
PUT #2 CHEMANALYTES&FIRSTCLASS - CHEMANALYTES&LASTCLASS;
RUN;

%OVERHEAD
RUN;
%GAPSGDERIVATIVES
RUN;
%SKIPAVER
RUN;
%MSCSNV
RUN;
%MEANCENTERVARSCALED
RUN;
%PREPAREFORPLS
RUN;

DATA SAVE; SET WORKFILE;
RUN;

DATA WORKFILE; SET WORKFILE;
IF &RANDOMIZE = "YES" THEN DO;
%LET NUMFILES = %SYSEVALF(&NUMCALFILES);
END;
RUN;

/*
DATA TEST; SET WORKFILE;
IF ID = &FIRSTFILE;
PROC PRINT;
RUN;
*/

%PLSMACRO
RUN;

DATA ALLRESULTS; INFILE "&CALPRED";
INPUT  METHOD $ ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS-P_CHEMANALYTES&LASTCLASS;
CALVAL = "CAL";
RUN;

DATA PRERESULTS; INFILE "&VALPRED";
INPUT  METHOD $ ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
CALVAL = "VAL";
RUN;

PROC APPEND BASE = ALLRESULTS DATA = PRERESULTS FORCE;
RUN;


PROC SORT DATA = ALLRESULTS;
BY CHEM IDERIVAT IFORM IMCVS IGAPS CALVAL;
RUN;

DATA ALLRESULTS; SET ALLRESULTS;
FILE "&COMBINEDPREDICTACTUAL" MOD;
PUT "&METHOD"  "   " ID $ IDLABEL $ CHEM IDERIVAT $ IFORM $ IMCVS $ IGAPS $ CALVAL $ CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
RUN;



DATA WORKFILE; SET SAVE;
IF &RANDOMIZE = "YES" THEN DO;
%LET NUMFILES = %SYSEVALF(&NUMCALFILES);
END;
RUN;

/*%LET METHOD = PCR;
RUN;
%PLSMACRO
RUN;

DATA ALLRESULTS; INFILE "&CALPRED";
INPUT  METHOD $ ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS-P_CHEMANALYTES&LASTCLASS;
CALVAL = "CAL";
RUN;

DATA PRERESULTS; INFILE "&VALPRED";
INPUT METHOD $ ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
CALVAL = "VAL";
RUN;

PROC APPEND BASE = ALLRESULTS DATA = PRERESULTS FORCE;
RUN;


PROC SORT DATA = ALLRESULTS;
BY CHEM IDERIVAT IFORM IMCVS IGAPS CALVAL;
RUN;

RUN;

DATA ALLRESULTS; SET ALLRESULTS;
FILE "&COMBINEDPREDICTACTUAL" MOD;
PUT "&METHOD"  "   "  ID $ IDLABEL $ CHEM IDERIVAT $ IFORM $ IMCVS $ IGAPS $ CALVAL $ CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
RUN;


DATA WORKFILE; SET SAVE;
IF &RANDOMIZE = "YES" THEN DO;
%LET NUMFILES = %SYSEVALF(&NUMCALFILES);
END;
RUN;*/

/*%LET METHOD = RRR;
RUN;
%PLSMACRO
RUN;

DATA ALLRESULTS; INFILE "&CALPRED";
INPUT  METHOD $ ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS-P_CHEMANALYTES&LASTCLASS;
CALVAL = "CAL";
RUN;

DATA PRERESULTS; INFILE "&VALPRED";
INPUT  METHOD $ ID $ CHEM IDLABEL $ IDERIVAT $ IFORM $ IMCVS $ IGAPS CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
CALVAL = "VAL";
RUN;

PROC APPEND BASE = ALLRESULTS DATA = PRERESULTS FORCE;
RUN;


PROC SORT DATA = ALLRESULTS;
BY CHEM IDERIVAT IFORM IMCVS IGAPS CALVAL;
RUN;




DATA ALLRESULTS; SET ALLRESULTS;
FILE "&COMBINEDPREDICTACTUAL" MOD;
PUT "&METHOD"  "   "  ID $ IDLABEL $ CHEM IDERIVAT $ IFORM $ IMCVS $ IGAPS $ CALVAL $ CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
RUN; */

LIBNAME STORGRAP ("&NAMEOFLIBRARY");
RUN;

/*%DO PLOTVAR = &FIRSTCLASS %TO &LASTCLASS;
     SYMBOL I = RLCLI99 V=DOT C=BLUE;
     PROC GPLOT GOUT = &COMBINEDGRAPHS DATA = ALLRESULTS;
          BY CHEM IDERIVAT IFORM IMCVS IGAPS CALVAL;
     PLOT P_CHEMANALYTES&PLOTVAR * CHEMANALYTES&PLOTVAR;
     RUN;
%END;
RUN;
*/

%MEND RUNRANDOM;

%MACRO RUNMANY;
%DO QQ = 1 %TO &ITERATIONS;
%RUNRANDOM
%END;
%MEND;

%RUNMANY
RUN;




%MACRO DISCRIMSUMMARY;

TITLE "DISCRIM PROGRAM SUMMARY PROGRAM RESULTS, STATISTICS SUMMARY";
RUN;

DATA OUTPUT;
METHOD = '...';
ANALYTEID = .;
IDERIVAT = '........';
IFORM = '........';
IMCVS = '........';
IGAPS = .;
NUMBEROFFACTORS = .;
SDIF = .;
SDSQ = .;
PRESS = .;
SEP = .;
SEPC = .;
BIAS = .;
RMSD = .;
VPRESS = .;
VSEP = .;
VSEPC = .;
VBIAS = .;
VRMSD = .;
CALR2 = .;
VALR2 = .;
RUN;

%MACRO READFILES;

%LET INPUTFILE = &NAMEALLSUMCALVAL&FF..TXT;

DATA SETIN; INFILE "&INPUTFILE";
INPUT METHOD $ 1-3 ANALYTEID IDERIVAT $ IFORM $ IMCVS $ IGAPS NUMBEROFFACTORS
        SDIF SDSQ PRESS SEP SEPC BIAS RMSD  VPRESS VSEP VSEPC VBIAS VRMSD
        CALR2 VALR2;

/*PROC PRINT;
RUN;*/

PROC APPEND BASE = OUTPUT DATA = SETIN FORCE;
RUN;


%MEND READFILES;

%MACRO READMANY;

%DO FF = 1 %TO &ITERATIONS;
   %READFILES
%END;

%MEND READMANY;

%READMANY

DATA OUTPUT; SET OUTPUT;
IF METHOD = '...' THEN DELETE;
RUN;

/*PROC PRINT DATA = OUTPUT;
RUN;

RUN;
*/

PROC SORT DATA = OUTPUT;
   BY  IDERIVAT IFORM IMCVS IGAPS  ANALYTEID METHOD;
RUN;

PROC MEANS  N MEAN MIN MAX CV NOPRINT;
   BY IDERIVAT IFORM IMCVS IGAPS  ANALYTEID METHOD;
   VAR NUMBEROFFACTORS RMSD VRMSD CALR2 VALR2;
   OUTPUT OUT = SUMCALVALSTATS MEAN = MNNUMBEROFFACTORS MNRMSD MNVRMSD MNCALR2 MNVALR2
                               STD = STDRMSD STDVRMSD STDCALR2 STDVALR2;
RUN;

PROC SORT DATA = SUMCALVALSTATS;
   BY  IDERIVAT IFORM IMCVS IGAPS  ANALYTEID METHOD;
RUN;

DATA SUMCALVALSTATS; SET SUMCALVALSTATS;
DROP _FREQ_ _TYPE_;
RUN;

PROC PRINT DATA = SUMCALVALSTATS;
RUN;


PROC SORT DATA = OUTPUT;
BY ANALYTEID METHOD;
RUN;

PROC MEANS DATA = OUTPUT NOPRINT;
   BY ANALYTEID METHOD;
   VAR NUMBEROFFACTORS RMSD VRMSD CALR2 VALR2;
   OUTPUT OUT = ALLSUMCALVALSTATS MEAN = MNNUMBEROFFACTORS MNRMSD MNVRMSD MNCALR2 MNVALR2
                                  STD = STDRMSD STDVRMSD STDCALR2 STDVALR2;
RUN;

PROC SORT DATA = ALLSUMCALVALSTATS;
   BY ANALYTEID METHOD;
RUN;

DATA ALLSUMCALVALSTATS; SET ALLSUMCALVALSTATS;
DROP _FREQ_ _TYPE_;
RUN;

PROC PRINT DATA = ALLSUMCALVALSTATS;
RUN;

%MEND DISCRIMSUMMARY;


%MACRO CLASSSUMMARY;

TITLE "DISCRIM SUMMARY PROGRAM RESULTS, FALSE POSTIVES AND NEGATIVES";
RUN;

%MACRO POSNEGS;

%LET COMBINEDPREDICTACTUAL = &NAMEALLPREDICTACTUAL&FF..SAV;

DATA POSNEGS; INFILE "&COMBINEDPREDICTACTUAL";
NEGATIVES = 0;
FALSEPOS = 0;
INPUT METHOD $ ID $ IDLABEL $ ANALYTEID IDERIVAT $ IFORM $ IMCVS $ IGAPS CALVAL $ CHEMANALYTES&FIRSTCLASS-CHEMANALYTES&LASTCLASS
         P_CHEMANALYTES&FIRSTCLASS - P_CHEMANALYTES&LASTCLASS;
RUN;

DATA POSNEGS; SET POSNEGS;
IF ANALYTEID = &FIRSTCLASS;
RUN;

DATA POSNEGS; SET POSNEGS;
     %DO PN1 = &FIRSTCLASS %TO &LASTCLASS;
              IF CHEMANALYTES&PN1 = 1 THEN
                    IF P_CHEMANALYTES&PN1 <  0.55 THEN NEGATIVES = NEGATIVES + 1;
              IF CHEMANALYTES&PN1 = 0 THEN
                    IF P_CHEMANALYTES&PN1 >  0.45 THEN FALSEPOS = FALSEPOS + 1;
    %END;

PROC SORT DATA = POSNEGS;
       BY  METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL;
RUN;


/*TITLE "POSNEGS";
/PROC PRINT DATA = POSNEGS;
RUN;
TITLE "     ";
*/

RUN;
PROC FREQ DATA = POSNEGS NOPRINT ;
     BY  METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL;
         TABLES NEGATIVES /
         OUT = NEGSOUT;
RUN;

/*PROC PRINT;
RUN;*/


PROC FREQ DATA = POSNEGS NOPRINT ;
     BY  METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL;
         TABLES FALSEPOS /
         OUT = POSSOUT;
RUN;

/*PROC PRINT;
RUN;*/

TITLE "DISCRIM SUMMARY PROGRAM RESULTS NEGATIVES";
RUN;
DATA NEGSOUT; SET NEGSOUT;
PERNEGS = PERCENT;
DROP PERCENT;
PROC PRINT;
RUN;


TITLE "DISCRIM SUMMARY PROGRAM RESULTS FALSE POSTIVES";
RUN;
DATA POSSOUT; SET POSSOUT;
PERPOSS = PERCENT;
DROP PERCENT;
PROC PRINT;
RUN;

PROC FREQ DATA = POSNEGS NOPRINT ;
     BY  METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL;
     TABLES NEGATIVES*FALSEPOS /
         OUT = CROSSNEGPOS ;
RUN;

PROC SORT DATA = CROSSNEGPOS;
    BY  METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL;
RUN;

TITLE "DISCRIM SUMMARY PROGRAM RESULTS FALSE POSTIVES X NEGATIVES";
RUN;
PROC PRINT DATA = CROSSNEGPOS;
RUN;

%MEND POSNEGS;


%MACRO COMBINE;

DATA ALLCROSSNEGPOS;
METHOD = '........';
IDERIVAT = '........';
IFORM = '........';
IMCVS = '........';
IGAPS = .;
CALVAL = '........';
COUNT = .;
PERCENT = .;
FALSEPOS = .;
NEGATIVES =.;
RUN;

DATA ALLNEGSOUT;
METHOD = '........';
IDERIVAT = '........';
IFORM = '........';
IMCVS = '........';
IGAPS = .;
CALVAL = '........';
COUNT = .;
PERNEGS = .;
NEGATIVES =.;
RUN;

DATA ALLPOSSOUT;
METHOD = '........';
IDERIVAT = '........';
IFORM = '........';
IMCVS = '........';
IGAPS = .;
CALVAL = '........';
COUNT = .;
PERPOSS = .;
FALSEPOS = .;
RUN;

%DO FF = 1 %TO &ITERATIONS;
     %POSNEGS
     PROC APPEND BASE = ALLCROSSNEGPOS DATA = CROSSNEGPOS FORCE;
     PROC APPEND BASE = ALLNEGSOUT DATA = NEGSOUT FORCE;
     PROC APPEND BASE = ALLPOSSOUT DATA = POSSOUT FORCE;
     RUN;
%END;

%MEND;


%COMBINE
RUN;


TITLE "ALL NEGATIVE RESULTS ALL ITERATIONS";
DATA ALLNEGSOUT; SET ALLNEGSOUT;
     IF METHOD = '........' THEN DELETE;
RUN;

PROC SORT DATA = ALLNEGSOUT;
     BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL NEGATIVES;
RUN;

PROC PRINT DATA = ALLNEGSOUT;
RUN;


TITLE "ALL FALSEPOS RESULTS FOR ALL ITERATIONS";
DATA ALLPOSSOUT; SET ALLPOSSOUT;
     IF METHOD = '........' THEN DELETE;
RUN;

PROC SORT DATA = ALLPOSSOUT;
     BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL FALSEPOS;
RUN;

PROC PRINT DATA = ALLPOSSOUT;
RUN;


TITLE "ALL CROSS NEGATIVES X POSITIVES RESULTS FOR ALL ITERATIONS";
DATA ALLCROSSNEGPOS; SET ALLCROSSNEGPOS;
     IF METHOD = '........' THEN DELETE;
RUN;

PROC SORT DATA = ALLCROSSNEGPOS;
     BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL FALSEPOS NEGATIVES;
RUN;

PROC PRINT DATA = ALLCROSSNEGPOS;
RUN;


TITLE "MEAN VALUES FOR ALL NEGATIVE RESULTS FOR ALL ITERATIONS";
PROC MEANS DATA = ALLNEGSOUT NOPRINT;
    BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL NEGATIVES;
    OUTPUT OUT = MNALLNEGSOUT MEAN = MCOUNT MPERNEGS MAX = MAXCOUNT MAXPERNEGS
                 MIN = MINCOUNT MINPERNEGS STD = STDCOUNT STDPERNEGS;
RUN;

PROC SORT DATA = MNALLNEGSOUT;
     BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL NEGATIVES;
RUN;

PROC PRINT DATA = MNALLNEGSOUT;
RUN;



TITLE "MEAN VALUES FOR ALL FALSEPOS RESULTS FOR ALL ITERATIONS";
PROC MEANS DATA = ALLPOSSOUT NOPRINT;
    BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL FALSEPOS;
    OUTPUT OUT = MNALLPOSSOUT MEAN = MCOUNT MPERPOSS MAX = MAXCOUNT MAXPERPOSS
                 MIN = MINCOUNT MINPERPOSS STD = STDCOUNT STDPERPOSS;
RUN;

PROC SORT DATA = MNALLPOSSOUT;
     BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL FALSEPOS;
RUN;

PROC PRINT DATA = MNALLPOSSOUT;
RUN;


TITLE "MEAN VALUES FOR ALLCROSS NEGATIVES X POSITIVES RESULTS";
PROC MEANS DATA = ALLCROSSNEGPOS NOPRINT;
    BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL FALSEPOS NEGATIVES;
    OUTPUT OUT = MNALLCROSSNEGPOS MEAN = MCOUNT MPERCENT MAX = MAXCOUNT MAXPERCENT
                 MIN = MINCOUNT MINPERCENT STD = STDCOUNT STDPERCENT;
RUN;

PROC SORT DATA = MNALLCROSSNEGPOS;
    BY METHOD IDERIVAT IFORM IMCVS IGAPS CALVAL FALSEPOS NEGATIVES;
RUN;

PROC PRINT DATA = MNALLCROSSNEGPOS;
RUN;


%MEND;

%DISCRIMSUMMARY
RUN;


/*%CLASSSUMMARY
RUN;*/

PROC PRINTTO;
RUN;
